
;CodeVisionAVR C Compiler V1.25.2 Beta1 Standard
;(C) Copyright 1998-2006 Pavel Haiduc, HP InfoTech s.r.l.
;http://www.hpinfotech.com

;Chip type              : ATmega8
;Program type           : Application
;Clock frequency        : 8,000000 MHz
;Memory model           : Small
;Optimize for           : Size
;(s)printf features     : int, width
;(s)scanf features      : int, width
;External SRAM size     : 0
;Data Stack size        : 256 byte(s)
;Heap size              : 0 byte(s)
;Promote char to int    : No
;char is unsigned       : Yes
;8 bit enums            : Yes
;Word align FLASH struct: Yes
;Enhanced core instructions    : On
;Automatic register allocation : On

	#pragma AVRPART ADMIN PART_NAME ATmega8
	#pragma AVRPART MEMORY PROG_FLASH 8192
	#pragma AVRPART MEMORY EEPROM 512
	#pragma AVRPART MEMORY INT_SRAM SIZE 1024
	#pragma AVRPART MEMORY INT_SRAM START_ADDR 0x60

	.EQU UDRE=0x5
	.EQU RXC=0x7
	.EQU USR=0xB
	.EQU UDR=0xC
	.EQU SPSR=0xE
	.EQU SPDR=0xF
	.EQU EERE=0x0
	.EQU EEWE=0x1
	.EQU EEMWE=0x2
	.EQU EECR=0x1C
	.EQU EEDR=0x1D
	.EQU EEARL=0x1E
	.EQU EEARH=0x1F
	.EQU WDTCR=0x21
	.EQU MCUCR=0x35
	.EQU GICR=0x3B
	.EQU SPL=0x3D
	.EQU SPH=0x3E
	.EQU SREG=0x3F

	.DEF R0X0=R0
	.DEF R0X1=R1
	.DEF R0X2=R2
	.DEF R0X3=R3
	.DEF R0X4=R4
	.DEF R0X5=R5
	.DEF R0X6=R6
	.DEF R0X7=R7
	.DEF R0X8=R8
	.DEF R0X9=R9
	.DEF R0XA=R10
	.DEF R0XB=R11
	.DEF R0XC=R12
	.DEF R0XD=R13
	.DEF R0XE=R14
	.DEF R0XF=R15
	.DEF R0X10=R16
	.DEF R0X11=R17
	.DEF R0X12=R18
	.DEF R0X13=R19
	.DEF R0X14=R20
	.DEF R0X15=R21
	.DEF R0X16=R22
	.DEF R0X17=R23
	.DEF R0X18=R24
	.DEF R0X19=R25
	.DEF R0X1A=R26
	.DEF R0X1B=R27
	.DEF R0X1C=R28
	.DEF R0X1D=R29
	.DEF R0X1E=R30
	.DEF R0X1F=R31

	.EQU __se_bit=0x80
	.EQU __sm_mask=0x70
	.EQU __sm_adc_noise_red=0x10
	.EQU __sm_powerdown=0x20
	.EQU __sm_powersave=0x30
	.EQU __sm_standby=0x60
	.EQU __sm_ext_standby=0x70

	.MACRO __CPD1N
	CPI  R30,LOW(@0)
	LDI  R26,HIGH(@0)
	CPC  R31,R26
	LDI  R26,BYTE3(@0)
	CPC  R22,R26
	LDI  R26,BYTE4(@0)
	CPC  R23,R26
	.ENDM

	.MACRO __CPD2N
	CPI  R26,LOW(@0)
	LDI  R30,HIGH(@0)
	CPC  R27,R30
	LDI  R30,BYTE3(@0)
	CPC  R24,R30
	LDI  R30,BYTE4(@0)
	CPC  R25,R30
	.ENDM

	.MACRO __CPWRR
	CP   R@0,R@2
	CPC  R@1,R@3
	.ENDM

	.MACRO __CPWRN
	CPI  R@0,LOW(@2)
	LDI  R30,HIGH(@2)
	CPC  R@1,R30
	.ENDM

	.MACRO __ADDB1MN
	SUBI R30,LOW(-@0-(@1))
	.ENDM
	.MACRO __ADDB2MN
	SUBI R26,LOW(-@0-(@1))
	.ENDM
	.MACRO __ADDW1MN
	SUBI R30,LOW(-@0-(@1))
	SBCI R31,HIGH(-@0-(@1))
	.ENDM
	.MACRO __ADDW2MN
	SUBI R26,LOW(-@0-(@1))
	SBCI R27,HIGH(-@0-(@1))
	.ENDM
	.MACRO __ADDW1FN
	SUBI R30,LOW(-2*@0-(@1))
	SBCI R31,HIGH(-2*@0-(@1))
	.ENDM
	.MACRO __ADDD1FN
	SUBI R30,LOW(-2*@0-(@1))
	SBCI R31,HIGH(-2*@0-(@1))
	SBCI R22,BYTE3(-2*@0-(@1))
	.ENDM
	.MACRO __ADDD1N
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	SBCI R22,BYTE3(-@0)
	SBCI R23,BYTE4(-@0)
	.ENDM

	.MACRO __ADDD2N
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	SBCI R24,BYTE3(-@0)
	SBCI R25,BYTE4(-@0)
	.ENDM

	.MACRO __SUBD1N
	SUBI R30,LOW(@0)
	SBCI R31,HIGH(@0)
	SBCI R22,BYTE3(@0)
	SBCI R23,BYTE4(@0)
	.ENDM

	.MACRO __SUBD2N
	SUBI R26,LOW(@0)
	SBCI R27,HIGH(@0)
	SBCI R24,BYTE3(@0)
	SBCI R25,BYTE4(@0)
	.ENDM

	.MACRO __ANDBMNN
	LDS  R30,@0+@1
	ANDI R30,LOW(@2)
	STS  @0+@1,R30
	.ENDM

	.MACRO __ANDWMNN
	LDS  R30,@0+@1
	ANDI R30,LOW(@2)
	STS  @0+@1,R30
	LDS  R30,@0+@1+1
	ANDI R30,HIGH(@2)
	STS  @0+@1+1,R30
	.ENDM

	.MACRO __ANDD1N
	ANDI R30,LOW(@0)
	ANDI R31,HIGH(@0)
	ANDI R22,BYTE3(@0)
	ANDI R23,BYTE4(@0)
	.ENDM

	.MACRO __ORBMNN
	LDS  R30,@0+@1
	ORI  R30,LOW(@2)
	STS  @0+@1,R30
	.ENDM

	.MACRO __ORWMNN
	LDS  R30,@0+@1
	ORI  R30,LOW(@2)
	STS  @0+@1,R30
	LDS  R30,@0+@1+1
	ORI  R30,HIGH(@2)
	STS  @0+@1+1,R30
	.ENDM

	.MACRO __ORD1N
	ORI  R30,LOW(@0)
	ORI  R31,HIGH(@0)
	ORI  R22,BYTE3(@0)
	ORI  R23,BYTE4(@0)
	.ENDM

	.MACRO __DELAY_USB
	LDI  R24,LOW(@0)
__DELAY_USB_LOOP:
	DEC  R24
	BRNE __DELAY_USB_LOOP
	.ENDM

	.MACRO __DELAY_USW
	LDI  R24,LOW(@0)
	LDI  R25,HIGH(@0)
__DELAY_USW_LOOP:
	SBIW R24,1
	BRNE __DELAY_USW_LOOP
	.ENDM

	.MACRO __CLRD1S
	LDI  R30,0
	STD  Y+@0,R30
	STD  Y+@0+1,R30
	STD  Y+@0+2,R30
	STD  Y+@0+3,R30
	.ENDM

	.MACRO __GETD1S
	LDD  R30,Y+@0
	LDD  R31,Y+@0+1
	LDD  R22,Y+@0+2
	LDD  R23,Y+@0+3
	.ENDM

	.MACRO __PUTD1S
	STD  Y+@0,R30
	STD  Y+@0+1,R31
	STD  Y+@0+2,R22
	STD  Y+@0+3,R23
	.ENDM

	.MACRO __PUTD2S
	STD  Y+@0,R26
	STD  Y+@0+1,R27
	STD  Y+@0+2,R24
	STD  Y+@0+3,R25
	.ENDM

	.MACRO __POINTB1MN
	LDI  R30,LOW(@0+@1)
	.ENDM

	.MACRO __POINTW1MN
	LDI  R30,LOW(@0+@1)
	LDI  R31,HIGH(@0+@1)
	.ENDM

	.MACRO __POINTD1M
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	.ENDM

	.MACRO __POINTW1FN
	LDI  R30,LOW(2*@0+@1)
	LDI  R31,HIGH(2*@0+@1)
	.ENDM

	.MACRO __POINTD1FN
	LDI  R30,LOW(2*@0+@1)
	LDI  R31,HIGH(2*@0+@1)
	LDI  R22,BYTE3(2*@0+@1)
	.ENDM

	.MACRO __POINTB2MN
	LDI  R26,LOW(@0+@1)
	.ENDM

	.MACRO __POINTW2MN
	LDI  R26,LOW(@0+@1)
	LDI  R27,HIGH(@0+@1)
	.ENDM

	.MACRO __POINTBRM
	LDI  R@0,LOW(@1)
	.ENDM

	.MACRO __POINTWRM
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __POINTBRMN
	LDI  R@0,LOW(@1+@2)
	.ENDM

	.MACRO __POINTWRMN
	LDI  R@0,LOW(@2+@3)
	LDI  R@1,HIGH(@2+@3)
	.ENDM

	.MACRO __POINTWRFN
	LDI  R@0,LOW(@2*2+@3)
	LDI  R@1,HIGH(@2*2+@3)
	.ENDM

	.MACRO __GETD1N
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	LDI  R23,BYTE4(@0)
	.ENDM

	.MACRO __GETD2N
	LDI  R26,LOW(@0)
	LDI  R27,HIGH(@0)
	LDI  R24,BYTE3(@0)
	LDI  R25,BYTE4(@0)
	.ENDM

	.MACRO __GETD2S
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	LDD  R24,Y+@0+2
	LDD  R25,Y+@0+3
	.ENDM

	.MACRO __GETB1MN
	LDS  R30,@0+@1
	.ENDM

	.MACRO __GETB1HMN
	LDS  R31,@0+@1
	.ENDM

	.MACRO __GETW1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	.ENDM

	.MACRO __GETD1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	LDS  R22,@0+@1+2
	LDS  R23,@0+@1+3
	.ENDM

	.MACRO __GETBRMN
	LDS  R@0,@1+@2
	.ENDM

	.MACRO __GETWRMN
	LDS  R@0,@2+@3
	LDS  R@1,@2+@3+1
	.ENDM

	.MACRO __GETWRZ
	LDD  R@0,Z+@2
	LDD  R@1,Z+@2+1
	.ENDM

	.MACRO __GETD2Z
	LDD  R26,Z+@0
	LDD  R27,Z+@0+1
	LDD  R24,Z+@0+2
	LDD  R25,Z+@0+3
	.ENDM

	.MACRO __GETB2MN
	LDS  R26,@0+@1
	.ENDM

	.MACRO __GETW2MN
	LDS  R26,@0+@1
	LDS  R27,@0+@1+1
	.ENDM

	.MACRO __GETD2MN
	LDS  R26,@0+@1
	LDS  R27,@0+@1+1
	LDS  R24,@0+@1+2
	LDS  R25,@0+@1+3
	.ENDM

	.MACRO __PUTB1MN
	STS  @0+@1,R30
	.ENDM

	.MACRO __PUTW1MN
	STS  @0+@1,R30
	STS  @0+@1+1,R31
	.ENDM

	.MACRO __PUTD1MN
	STS  @0+@1,R30
	STS  @0+@1+1,R31
	STS  @0+@1+2,R22
	STS  @0+@1+3,R23
	.ENDM

	.MACRO __PUTBR0MN
	STS  @0+@1,R0
	.ENDM

	.MACRO __PUTDZ2
	STD  Z+@0,R26
	STD  Z+@0+1,R27
	STD  Z+@0+2,R24
	STD  Z+@0+3,R25
	.ENDM

	.MACRO __PUTBMRN
	STS  @0+@1,R@2
	.ENDM

	.MACRO __PUTWMRN
	STS  @0+@1,R@2
	STS  @0+@1+1,R@3
	.ENDM

	.MACRO __PUTBZR
	STD  Z+@1,R@0
	.ENDM

	.MACRO __PUTWZR
	STD  Z+@2,R@0
	STD  Z+@2+1,R@1
	.ENDM

	.MACRO __GETW1R
	MOV  R30,R@0
	MOV  R31,R@1
	.ENDM

	.MACRO __GETW2R
	MOV  R26,R@0
	MOV  R27,R@1
	.ENDM

	.MACRO __GETWRN
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __PUTW1R
	MOV  R@0,R30
	MOV  R@1,R31
	.ENDM

	.MACRO __PUTW2R
	MOV  R@0,R26
	MOV  R@1,R27
	.ENDM

	.MACRO __ADDWRN
	SUBI R@0,LOW(-@2)
	SBCI R@1,HIGH(-@2)
	.ENDM

	.MACRO __ADDWRR
	ADD  R@0,R@2
	ADC  R@1,R@3
	.ENDM

	.MACRO __SUBWRN
	SUBI R@0,LOW(@2)
	SBCI R@1,HIGH(@2)
	.ENDM

	.MACRO __SUBWRR
	SUB  R@0,R@2
	SBC  R@1,R@3
	.ENDM

	.MACRO __ANDWRN
	ANDI R@0,LOW(@2)
	ANDI R@1,HIGH(@2)
	.ENDM

	.MACRO __ANDWRR
	AND  R@0,R@2
	AND  R@1,R@3
	.ENDM

	.MACRO __ORWRN
	ORI  R@0,LOW(@2)
	ORI  R@1,HIGH(@2)
	.ENDM

	.MACRO __ORWRR
	OR   R@0,R@2
	OR   R@1,R@3
	.ENDM

	.MACRO __EORWRR
	EOR  R@0,R@2
	EOR  R@1,R@3
	.ENDM

	.MACRO __GETWRS
	LDD  R@0,Y+@2
	LDD  R@1,Y+@2+1
	.ENDM

	.MACRO __PUTWSR
	STD  Y+@2,R@0
	STD  Y+@2+1,R@1
	.ENDM

	.MACRO __MOVEWRR
	MOV  R@0,R@2
	MOV  R@1,R@3
	.ENDM

	.MACRO __INWR
	IN   R@0,@2
	IN   R@1,@2+1
	.ENDM

	.MACRO __OUTWR
	OUT  @2+1,R@1
	OUT  @2,R@0
	.ENDM

	.MACRO __CALL1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	ICALL
	.ENDM

	.MACRO __CALL1FN
	LDI  R30,LOW(2*@0+@1)
	LDI  R31,HIGH(2*@0+@1)
	RCALL __GETW1PF
	ICALL
	.ENDM

	.MACRO __CALL2EN
	LDI  R26,LOW(@0+@1)
	LDI  R27,HIGH(@0+@1)
	RCALL __EEPROMRDW
	ICALL
	.ENDM

	.MACRO __GETW1STACK
	IN   R26,SPL
	IN   R27,SPH
	ADIW R26,@0+1
	LD   R30,X+
	LD   R31,X
	.ENDM

	.MACRO __NBST
	BST  R@0,@1
	IN   R30,SREG
	LDI  R31,0x40
	EOR  R30,R31
	OUT  SREG,R30
	.ENDM


	.MACRO __PUTB1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RNS
	MOVW R26,R@0
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RNS
	MOVW R26,R@0
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RNS
	MOVW R26,R@0
	ADIW R26,@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	RCALL __PUTDP1
	.ENDM


	.MACRO __GETB1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R30,Z
	.ENDM

	.MACRO __GETB1HSX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	.ENDM

	.MACRO __GETW1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R31,Z
	MOV  R30,R0
	.ENDM

	.MACRO __GETD1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R1,Z+
	LD   R22,Z+
	LD   R23,Z
	MOVW R30,R0
	.ENDM

	.MACRO __GETB2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R26,X
	.ENDM

	.MACRO __GETW2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	.ENDM

	.MACRO __GETD2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R1,X+
	LD   R24,X+
	LD   R25,X
	MOVW R26,R0
	.ENDM

	.MACRO __GETBRSX
	MOVW R30,R28
	SUBI R30,LOW(-@1)
	SBCI R31,HIGH(-@1)
	LD   R@0,Z
	.ENDM

	.MACRO __GETWRSX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	LD   R@0,Z+
	LD   R@1,Z
	.ENDM

	.MACRO __LSLW8SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	CLR  R30
	.ENDM

	.MACRO __PUTB1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __CLRW1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	CLR  R0
	ST   Z+,R0
	ST   Z,R0
	.ENDM

	.MACRO __CLRD1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	CLR  R0
	ST   Z+,R0
	ST   Z+,R0
	ST   Z+,R0
	ST   Z,R0
	.ENDM

	.MACRO __PUTB2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z,R26
	.ENDM

	.MACRO __PUTW2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z,R27
	.ENDM

	.MACRO __PUTD2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z+,R27
	ST   Z+,R24
	ST   Z,R25
	.ENDM

	.MACRO __PUTBSRX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z,R@1
	.ENDM

	.MACRO __PUTWSRX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	ST   Z+,R@0
	ST   Z,R@1
	.ENDM

	.MACRO __PUTB1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __MULBRR
	MULS R@0,R@1
	MOVW R30,R0
	.ENDM

	.MACRO __MULBRRU
	MUL  R@0,R@1
	MOVW R30,R0
	.ENDM

	.MACRO __MULBRR0
	MULS R@0,R@1
	.ENDM

	.MACRO __MULBRRU0
	MUL  R@0,R@1
	.ENDM

	.MACRO __MULBNWRU
	LDI  R26,@2
	MUL  R26,R@0
	MOVW R30,R0
	MUL  R26,R@1
	ADD  R31,R0
	.ENDM

	.CSEG
	.ORG 0

	.INCLUDE "111.vec"
	.INCLUDE "111.inc"

__RESET:
	CLI
	CLR  R30
	OUT  EECR,R30

;INTERRUPT VECTORS ARE PLACED
;AT THE START OF FLASH
	LDI  R31,1
	OUT  GICR,R31
	OUT  GICR,R30
	OUT  MCUCR,R30

;DISABLE WATCHDOG
	LDI  R31,0x18
	OUT  WDTCR,R31
	OUT  WDTCR,R30

;CLEAR R2-R14
	LDI  R24,13
	LDI  R26,2
	CLR  R27
__CLEAR_REG:
	ST   X+,R30
	DEC  R24
	BRNE __CLEAR_REG

;CLEAR SRAM
	LDI  R24,LOW(0x400)
	LDI  R25,HIGH(0x400)
	LDI  R26,0x60
__CLEAR_SRAM:
	ST   X+,R30
	SBIW R24,1
	BRNE __CLEAR_SRAM

;GLOBAL VARIABLES INITIALIZATION
	LDI  R30,LOW(__GLOBAL_INI_TBL*2)
	LDI  R31,HIGH(__GLOBAL_INI_TBL*2)
__GLOBAL_INI_NEXT:
	LPM  R24,Z+
	LPM  R25,Z+
	SBIW R24,0
	BREQ __GLOBAL_INI_END
	LPM  R26,Z+
	LPM  R27,Z+
	LPM  R0,Z+
	LPM  R1,Z+
	MOVW R22,R30
	MOVW R30,R0
__GLOBAL_INI_LOOP:
	LPM  R0,Z+
	ST   X+,R0
	SBIW R24,1
	BRNE __GLOBAL_INI_LOOP
	MOVW R30,R22
	RJMP __GLOBAL_INI_NEXT
__GLOBAL_INI_END:

;STACK POINTER INITIALIZATION
	LDI  R30,LOW(0x45F)
	OUT  SPL,R30
	LDI  R30,HIGH(0x45F)
	OUT  SPH,R30

;DATA STACK POINTER INITIALIZATION
	LDI  R28,LOW(0x160)
	LDI  R29,HIGH(0x160)

	RJMP _main

	.ESEG
	.ORG 0
	.DB  0 ; FIRST EEPROM LOCATION NOT USED, SEE ATMEL ERRATA SHEETS

	.DSEG
	.ORG 0x160
;       1 #include <mega8.h>    
;       2 #include <stdio.h>
;       3 #include <delay.h>
;       4 #include <String.h>   //      memcpy
;       5 
;       6 //#define TRFreset    0   //  - ,    ,  
;       7 #define TRFSYNC     0   //  -  HEADER
;       8 #define TRFwait     2   //  -       
;       9 #define TRFError    3 
;      10 #define TRFError2    4   //  - 
;      11 #define TRFSkip     5   //  - 
;      12 #define TRFSkip2    6            
;      13 
;      14 #define BGRX_Wait   0
;      15 #define BGRX_Run    1
;      16 #define BGRX_Zero   2
;      17 //#define BGRX_NoiseH 3
;      18 //#define BGRX_NoiseL 4
;      19 
;      20 #define W           0
;      21 #define R           1
;      22 
;      23 #define Cell_0      0
;      24 #define Cell_1      1
;      25 #define Cell_2      2
;      26 
;      27 #define WrCell_0    0
;      28 #define WrCell_1    1
;      29 #define WrCell_2    2
;      30 
;      31 #define TE           400        //
;      32 
;      33 #define SHORT_HEAD   20         //   
;      34 #define LONG_HEAD    40         //   
;      35 
;      36 #define NBIT         62     // number of bit to receive -1
;      37 
;      38 //#################################################                      
;      39 #define RFInM 	  PINC.5	//              			
;      40 //#define TETest 	  PORTC.1	//
;      41 #define RFOut 	  PORTD.2	//						
;      42 //#define Switch	  PORTD.0       //PIN                           
;      43 
;      44 //#define BtnT 	  PINB.7	// 
;      45 //#define BtnM 	  PINC.5	// 
;      46 
;      47 #define BtnMode    PINC.2	//   
;      48 #define BtnTx      PINC.3	// 
;      49 #define BtnMem     PINC.4	//   		
;      50 
;      51 #define LedR 	  PORTC.0	//     LedR-
;      52 #define LedG 	  PORTC.1	//
;      53 //#define LedB 	  PORTD.3	//
;      54 
;      55 //#define LedM1 	  PORTC.3	//
;      56 //#define LedM2 	  PORTC.2	//
;      57 //#define LedM3 	  PORTC.1	//
;      58 
;      59 #define Beeper 	  PORTD.3	//
;      60 //#define Vibro 	  PORTD.1	//
;      61 //#################################################
;      62 
;      63 typedef unsigned char byte; // unsigned char  "byte"
;      64 //typedef unsigned int byte;      // one byte unsigned
;      65 typedef signed   int  sbyte;     // one byte signed
;      66 typedef signed   long word;      // one word signed
;      67 
;      68 #pragma warn- //    
;      69 eeprom byte EprBuf0 [65];	// 0   

	.ESEG
_EprBuf0:
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
;      70 eeprom byte EprBuf1 [65];	// 1   
_EprBuf1:
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
;      71 eeprom byte EprBuf2 [65];	//  2  - 
_EprBuf2:
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
;      72 
;      73 eeprom byte eep_ring;
_eep_ring:
	.DB  0x0
;      74 #pragma warn+ //   
;      75 
;      76 //int   TE_Test_CNT;
;      77 
;      78 int   RFcount;           //  TE
;      79 int   BGRXcnt;                        
;      80 int   LastRxCnt;   
;      81 int   LedPulse;
;      82 
;      83 int  NError;                             
;      84 //byte  ErrLength;
;      85 
;      86 //byte  ErrLevel;
;      87 
;      88 byte  BGRX;
;      89 byte  RFstate;   //  - 

	.DSEG
_RFstate:
	.BYTE 0x1
;      90 byte  BitCount;          //   
_BitCount:
	.BYTE 0x1
;      91 //byte  L3FErCNT;
;      92 
;      93 bit   ActiveBuf;         //   (         )
;      94 bit   RFFull;           //               
;      95 bit   TXFlag;           //         
;      96 
;      97 //byte  ring;                                
;      98 byte  CellNo;      
_CellNo:
	.BYTE 0x1
;      99 byte  Grab; //  0,1     2 -   
_Grab:
	.BYTE 0x1
;     100 byte  begin;
_begin:
	.BYTE 0x1
;     101 
;     102 //bit   RFBitM;            //     
;     103 //bit   RFBitS;            //     
;     104 
;     105 byte i;                 //  i     for
_i:
	.BYTE 0x1
;     106 
;     107 byte	    RxBuf   [65];   // /
_RxBuf:
	.BYTE 0x41
;     108 byte	    RxBufLox[65];	//     
_RxBufLox:
	.BYTE 0x41
;     109 
;     110 byte	    RxBuf1  [65];	//   1
_RxBuf1:
	.BYTE 0x41
;     111 byte	    RxBuf2  [65];	//   2
_RxBuf2:
	.BYTE 0x41
;     112 
;     113 //   
;     114 #include "TX.c"             // 
;     115 void Beep2(void);
;     116 void Beep(void);
;     117 void SetActive (void);
;     118 
;     119 //+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
;     120 byte SnCmpr(byte *TestBuf)
;     121 {//    

	.CSEG
_SnCmpr:
;     122 byte HOPcmp;    
;     123 //RFFull=1;
;     124 
;     125 for (i = 32; i != 60; i ++)
	ST   -Y,R16
;	*TestBuf -> Y+1
;	HOPcmp -> R16
	LDI  R30,LOW(32)
	RCALL SUBOPT_0x0
_0x4:
	RCALL SUBOPT_0x1
	CPI  R26,LOW(0x3C)
	BREQ _0x5
;     126     {
;     127     if (RxBuf[i] != TestBuf[i])
	RCALL SUBOPT_0x2
	RCALL SUBOPT_0x3
	RCALL SUBOPT_0x4
	BREQ _0x6
;     128        {		     
;     129   //     RFFull=0;  //   ,   
;     130        return 0;  //   0
	LDI  R30,LOW(0)
	RJMP _0xA2
;     131        }		                 
;     132     }   
_0x6:
	RCALL SUBOPT_0x5
	RJMP _0x4
_0x5:
;     133 
;     134 //***	
;     135 
;     136 for (i = 0; i != 32; i ++) //  
	RCALL SUBOPT_0x6
_0x8:
	RCALL SUBOPT_0x1
	CPI  R26,LOW(0x20)
	BREQ _0x9
;     137     {
;     138     if (RxBuf[i] != TestBuf[i])
	RCALL SUBOPT_0x2
	RCALL SUBOPT_0x3
	RCALL SUBOPT_0x4
	BREQ _0xA
;     139        {		     
;     140        HOPcmp=1;      
	LDI  R16,LOW(1)
;     141        }		                 
;     142     }      
_0xA:
	RCALL SUBOPT_0x5
	RJMP _0x8
_0x9:
;     143     
;     144 if (!HOPcmp)      	
	CPI  R16,0
	BRNE _0xB
;     145     return 0;
	LDI  R30,LOW(0)
	RJMP _0xA2
;     146 
;     147 //***   	
;     148 		         
;     149 for (i = 60; i != 63; i ++) // 
_0xB:
	LDI  R30,LOW(60)
	RCALL SUBOPT_0x0
_0xD:
	RCALL SUBOPT_0x1
	CPI  R26,LOW(0x3F)
	BREQ _0xE
;     150     {
;     151     if (RxBuf[i] != TestBuf[i])
	RCALL SUBOPT_0x7
	RCALL SUBOPT_0x4
	BREQ _0xF
;     152        {		     
;     153        return 2;      
	LDI  R30,LOW(2)
	RJMP _0xA2
;     154        }		                 
;     155     }   
_0xF:
	RCALL SUBOPT_0x5
	RJMP _0xD
_0xE:
;     156        	 
;     157     	         		         
;     158 return 1;		         
	LDI  R30,LOW(1)
_0xA2:
	LDD  R16,Y+0
	ADIW R28,3
	RET
;     159 } 
;     160 //-------------------------------------------------------------------------------------------------------------------------
;     161 //#########################################################################################################################
;     162 
;     163 void TX (byte* TxBuf)
;     164 {           
_TX:
;     165 
;     166 BGRX    = BGRX_Wait;
;	*TxBuf -> Y+0
	CLR  R14
;     167 RFstate = TRFwait;                 
	LDI  R30,LOW(2)
	RCALL SUBOPT_0x8
;     168 
;     169 //#asm("cli") 
;     170 LedR=1;
	SBI  0x15,0
;     171 //Vibro=0; 
;     172 //Switch=1; // 
;     173 //========================================================================_Prambule	
;     174 //    24 :  =0  a=23,    1 
;     175 	for(i = 0; i != 31; i++)
	RCALL SUBOPT_0x6
_0x11:
	RCALL SUBOPT_0x1
	CPI  R26,LOW(0x1F)
	BREQ _0x12
;     176        	{
;     177        		RFOut = 0;
	CBI  0x12,2
;     178        		delay_us(TE);
	RCALL SUBOPT_0x9
;     179 
;     180        		RFOut = 1;       		
	SBI  0x12,2
;     181        		delay_us(TE); 
	RCALL SUBOPT_0x9
;     182        	}
	RCALL SUBOPT_0x5
	RJMP _0x11
_0x12:
;     183 //========================================================================_HeaderTX
;     184 RFOut = 0;
	CBI  0x12,2
;     185 delay_ms (4);
	LDI  R30,LOW(4)
	LDI  R31,HIGH(4)
	RCALL SUBOPT_0xA
;     186 //========================================================================_BuffTX
;     187 //--------------------------------//1- 
;     188 //    
;     189    
;     190    for(i = 0; i != 66; i++) //
	RCALL SUBOPT_0x6
_0x14:
	RCALL SUBOPT_0xB
	BREQ _0x15
;     191    {
;     192     RFOut = 1;      
	SBI  0x12,2
;     193         
;     194 //    if (ring!=1)
;     195         Beeper= 1;
	SBI  0x12,3
;     196         
;     197     delay_us(TE);    
	RCALL SUBOPT_0x9
;     198       
;     199     RFOut=TxBuf[i];       
	RCALL SUBOPT_0x2
	LD   R26,Y
	LDD  R27,Y+1
	RCALL SUBOPT_0x3
	ADD  R26,R30
	ADC  R27,R31
	LD   R30,X
	RCALL __BSTB1
	IN   R26,0x12
	BLD  R26,2
	OUT  0x12,R26
;     200     delay_us(TE);
	RCALL SUBOPT_0x9
;     201 
;     202     RFOut = 0;    
	CBI  0x12,2
;     203     Beeper= 0;
	CBI  0x12,3
;     204     delay_us(TE);
	RCALL SUBOPT_0x9
;     205    }  
	RCALL SUBOPT_0x5
	RJMP _0x14
_0x15:
;     206     /*
;     207     RFOut = 1;      
;     208     delay_us(TE);    
;     209       
;     210     RFOut=0;       
;     211     delay_us(TE);
;     212 
;     213     RFOut = 0;    
;     214     delay_us(TE);
;     215 */                  
;     216     
;     217 //========================================================================_GuardTime                                                  
;     218 //Switch = 0;      //   =)
;     219 //Vibro=1; 
;     220 LedR=0;    
	CBI  0x15,0
;     221 RFFull=0;
	CLT
	BLD  R2,1
;     222 //#asm("sei") 
;     223 delay_ms (10);	//  15ms,       	 
	RCALL SUBOPT_0xC
	RCALL SUBOPT_0xA
;     224 
;     225 RFstate = TRFSYNC;
	RCALL SUBOPT_0xD
;     226 }      
	ADIW R28,2
	RET
;     227 
;     228 
;     229 //#########################################################################################################################
;     230 //+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
;     231 void BTNcomp(void) //   
;     232 {
_BTNcomp:
;     233 if ((Grab>1 && SnCmpr(RxBufLox)==2) && Grab<4) //   - Grab = 1  //    
	RCALL SUBOPT_0xE
	CPI  R26,LOW(0x2)
	BRLO _0x17
	RCALL SUBOPT_0xF
	RCALL _SnCmpr
	CPI  R30,LOW(0x2)
	BREQ _0x18
_0x17:
	RJMP _0x19
_0x18:
	RCALL SUBOPT_0xE
	CPI  R26,LOW(0x4)
	BRLO _0x1A
_0x19:
	RJMP _0x16
_0x1A:
;     234    {                                                                                                           
;     235    Grab++;   
	LDS  R30,_Grab
	SUBI R30,-LOW(1)
	RCALL SUBOPT_0x10
;     236    if (ActiveBuf==0)//   Buf0(    )
	SBRC R2,0
	RJMP _0x1B
;     237       {
;     238       ActiveBuf = 1;
	RCALL SUBOPT_0x11
;     239       TX(RxBuf2); 
	RCALL _TX
;     240       Beep();
	RCALL _Beep
;     241       TX(RxBuf2);
	RCALL SUBOPT_0x12
	RJMP _0xA3
;     242       }
;     243   else//   Buf1(    ),   Buf0
_0x1B:
;     244       {            
;     245       ActiveBuf = 0;
	RCALL SUBOPT_0x13
;     246       TX(RxBuf1); 
	RCALL _TX
;     247       Beep();   
	RCALL _Beep
;     248       TX(RxBuf1);
	RCALL SUBOPT_0x14
_0xA3:
	ST   -Y,R31
	ST   -Y,R30
	RCALL _TX
;     249       }            
;     250    }                           
;     251    
;     252 //-----------------------------------------------------------------------------------------------------------------
;     253 
;     254 if (Grab==1  && RFFull) //     ,    
_0x16:
	RCALL SUBOPT_0x15
	BRNE _0x1E
	SBRC R2,1
	RJMP _0x1F
_0x1E:
	RJMP _0x1D
_0x1F:
;     255    {                                                                     
;     256    TX(RxBuf);    
	RCALL SUBOPT_0x16
;     257    Beep();
	RCALL _Beep
;     258    TX(RxBuf);       
	RCALL SUBOPT_0x16
;     259    }
;     260                                          
;     261 }  
_0x1D:
	RET
;     262 
;     263 //#########################################################################################################################
;     264 
;     265 
;     266 void SetActive (void)
;     267 {                                                       
_SetActive:
;     268 if ( (SnCmpr(RxBuf1)==2 || SnCmpr(RxBuf2)==2) && begin >= 2 && Grab==0) 
	RCALL SUBOPT_0x17
	CPI  R30,LOW(0x2)
	BREQ _0x21
	RCALL SUBOPT_0x18
	CPI  R30,LOW(0x2)
	BRNE _0x23
_0x21:
	LDS  R26,_begin
	CPI  R26,LOW(0x2)
	BRLO _0x23
	RCALL SUBOPT_0xE
	CPI  R26,LOW(0x0)
	BREQ _0x24
_0x23:
	RJMP _0x20
_0x24:
;     269 // if ( (((SnCmpr(RxBuf1)==2) || (SnCmpr(RxBuf2)==2)) && (Grab!=2)) && (begin >= 2) && (Grab!=1)) 
;     270     {          
;     271     memcpy(RxBufLox,RxBuf, 65); //   LOX                 //         
	RCALL SUBOPT_0xF
	RCALL SUBOPT_0x19
;     272     RFFull=1;
	SET
	BLD  R2,1
;     273     LedG=1;         
	SBI  0x15,1
;     274     Grab=2;      
	LDI  R30,LOW(2)
	RCALL SUBOPT_0x10
;     275     Beep2();
	RCALL _Beep2
;     276     }                       
;     277     
;     278 //--------------------------------------------------------------------------------------------------------
;     279 
;     280 if (Grab<2 && ( SnCmpr(RxBuf1) || SnCmpr(RxBuf2) || begin<2 ) )                                                 //      
_0x20:
	RCALL SUBOPT_0xE
	CPI  R26,LOW(0x2)
	BRSH _0x26
	RCALL SUBOPT_0x17
	CPI  R30,0
	BRNE _0x27
	RCALL SUBOPT_0x18
	CPI  R30,0
	BRNE _0x27
	LDS  R26,_begin
	CPI  R26,LOW(0x2)
	BRSH _0x26
_0x27:
	RJMP _0x29
_0x26:
	RJMP _0x25
_0x29:
;     281    {                                                    
;     282    if (ActiveBuf==0)//   Buf0(    )
	SBRC R2,0
	RJMP _0x2A
;     283       {                                              
;     284          ActiveBuf = 1;		//  Buf1                       
	RCALL SUBOPT_0x11
;     285          memcpy(RxBuf2,RxBuf, 65); //   RxBuf2                          
	RCALL SUBOPT_0x19
;     286          memcpy(RxBuf, RxBuf1,65); //  RxBuf1   
	RCALL SUBOPT_0x1A
	RCALL SUBOPT_0x14
	RJMP _0xA4
;     287          RFFull=1;
;     288       }
;     289    else//   Buf1(    ),   Buf0
_0x2A:
;     290        {   
;     291   	      ActiveBuf = 0;		//  Buf0      
	RCALL SUBOPT_0x13
;     292 	      memcpy(RxBuf1, RxBuf,65); //   RxBuf1     
	RCALL SUBOPT_0x19
;     293 	      memcpy(RxBuf, RxBuf2,65);//  RxBuf2         
	RCALL SUBOPT_0x1A
	RCALL SUBOPT_0x12
_0xA4:
	ST   -Y,R31
	ST   -Y,R30
	RCALL SUBOPT_0x1B
;     294 	      RFFull=1;
	SET
	BLD  R2,1
;     295        }        
;     296    }    
;     297 
;     298 }
_0x25:
	RET
;     299 
;     300 
;     301 #include "HDetect.c"           //         
;     302 //+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
;     303 //interrupt [TIM0_OVF] void MainRecive(void) // ,   
;     304 interrupt [TIM0_OVF] void timer0_ovf_isr(void)
;     305 {
_timer0_ovf_isr:
	ST   -Y,R30
	ST   -Y,R31
	IN   R30,SREG
	ST   -Y,R30
;     306 //#############  +
;     307 TCNT0=135;
	LDI  R30,LOW(135)
	OUT  0x32,R30
;     308 // - ,  - 
;     309         
;     310 //LedG=0;
;     311 //LedR=0;
;     312  
;     313 NError++;
	MOVW R30,R12
	ADIW R30,1
	MOVW R12,R30
;     314 /*      if (NError >= 50)
;     315 	 {          	           		   
;     316 	 NError = 0; 
;     317 	 if (RFstate == TRFSYNC)
;     318             {
;     319             Switch = 1;            
;     320 	    RFstate = TRFError;
;     321 //	    LedR   = 1;
;     322 	    RFOut  = 1;
;     323 	    
;     324             BGRXcnt = 0;     
;     325 //          RFcount = 0;    
;     326             }	 
;     327 	 } */
;     328 
;     329 switch(RFstate)  //           
	LDS  R30,_RFstate
;     330 {
;     331 //************************************************
;     332 
;     333 //************************************************
;     334  case TRFError: //   ,  HEADER
	CPI  R30,LOW(0x3)
	BRNE _0x2F
;     335 
;     336 
;     337 // RFcount+10;      
;     338 
;     339 /* delay_us(400);
;     340  RFOut = 0;
;     341  delay_us(50); 
;     342  RFOut = 1;    
;     343  delay_us(200);   */
;     344         
;     345 // delay_us(150);   
;     346  
;     347  //RFcount=20;         
;     348 // LedR=0;
;     349 // LedG=0;        
;     350  RFOut = 0;  
	CBI  0x12,2
;     351  RFstate = TRFError2; 
	LDI  R30,LOW(4)
	RCALL SUBOPT_0x8
;     352  
;     353  break;
	RJMP _0x2E
;     354 
;     355 //************************************************
;     356 
;     357  case TRFError2: //   ,  HEADER     
_0x2F:
	CPI  R30,LOW(0x4)
	BRNE _0x30
;     358                    
;     359       RFOut = 1;
	SBI  0x12,2
;     360       RFstate = TRFSkip;
	LDI  R30,LOW(5)
	RCALL SUBOPT_0x8
;     361  
;     362  break;
	RJMP _0x2E
;     363 //************************************************ 
;     364 
;     365  case TRFSkip: //   ,  HEADER     
_0x30:
	CPI  R30,LOW(0x5)
	BRNE _0x31
;     366                    
;     367       RFOut = 0;         
	CBI  0x12,2
;     368       //delay_us(100);
;     369       RFstate = TRFSkip2; 
	LDI  R30,LOW(6)
	RCALL SUBOPT_0x8
;     370  
;     371  break;                                             
	RJMP _0x2E
;     372  
;     373  //************************************************ 
;     374 
;     375  case TRFSkip2: //   ,  HEADER     
_0x31:
	CPI  R30,LOW(0x6)
	BRNE _0x32
;     376                              
;     377 //      Switch = 0;        
;     378       RFstate = TRFSYNC; 
	RCALL SUBOPT_0xD
;     379  
;     380  break;
	RJMP _0x2E
;     381 //************************************************************************************************************************************
;     382 
;     383  case TRFwait://   
_0x32:
	CPI  R30,LOW(0x2)
	BRNE _0x33
;     384                                         
;     385  //LedR=1;
;     386  RFcount = 0; //          
	CLR  R4
	CLR  R5
;     387 
;     388  break;
	RJMP _0x2E
;     389 
;     390 //*************************************************
;     391  case TRFSYNC: //                       
_0x33:
	CPI  R30,0
	BRNE _0x35
;     392                              
;     393  default:                                      
_0x35:
;     394               
;     395 /*      if (NError >= 50)
;     396 	 {          	           		   
;     397 	 NError = 0;
;     398          Switch = 1;   
;     399          RFOut  = 1;            
;     400 	 RFstate = TRFError;  
;     401 	 }    */   
;     402                       
;     403  if (RFInM == 1)
	SBIS 0x13,5
	RJMP _0x36
;     404     {            
;     405     //LedG=1;
;     406     
;     407     
;     408 //     TETest=1; //               !!!        
;     409      // rising edge detected  +---+                +---..
;     410      //                       |   |  <-Theader->   |   
;     411      //                           +----------------+                                                                
;     412      BGRXcnt = 0;
	CLR  R6
	CLR  R7
;     413      RFcount = 0;      	                                    
	CLR  R4
	CLR  R5
;     414      BitCount= 0; 
	LDI  R30,LOW(0)
	STS  _BitCount,R30
;     415      //L3FErCNT= 0;                                                             
;     416      RFstate = TRFwait;                 
	LDI  R30,LOW(2)
	RCALL SUBOPT_0x8
;     417      BGRX = BGRX_Run;      
	LDI  R30,LOW(1)
	MOV  R14,R30
;     418      //RFcount = 0; // HEADER-a  0
;     419      //NError = 0;  //   0                     
;     420     }
;     421     
;     422  else
	RJMP _0x37
_0x36:
;     423      {      
;     424      //LedR=1;
;     425      
;     426 //     TETest=0; //               !!!         
;     427      RFcount++; //  HEADER	          
	MOVW R30,R4
	ADIW R30,1
	MOVW R4,R30
	SBIW R30,1
;     428      if (RFcount == 10)// && NError > 50 )
	RCALL SUBOPT_0xC
	CP   R30,R4
	CPC  R31,R5
	BRNE _0x38
;     429         {            
;     430          NError = 0;
	CLR  R12
	CLR  R13
;     431         // RFcount= 0;                                                        
;     432          RFstate = TRFError; 	      
	LDI  R30,LOW(3)
	RCALL SUBOPT_0x8
;     433 //         Switch= 1;	 
;     434 	 RFOut = 1; 
	SBI  0x12,2
;     435         }      
;     436      }                
_0x38:
_0x37:
;     437 
;     438 break;
;     439 
;     440 //*************************************************************************************************************************************
;     441        
;     442     } // switch    */     
_0x2E:
;     443  
;     444 }
	LD   R30,Y+
	OUT  SREG,R30
	LD   R31,Y+
	LD   R30,Y+
	RETI
;     445 #include "rx_code.c"           //         
;     446 void RFError(void) //   
;     447 {
_RFError:
;     448 //Switch = 1; 
;     449 RFOut=1;
	SBI  0x12,2
;     450 
;     451 //if (ring!=1)
;     452 	for(i = 0; i != 10; i++)
	RCALL SUBOPT_0x6
_0x3A:
	RCALL SUBOPT_0x1
	CPI  R26,LOW(0xA)
	BREQ _0x3B
;     453 	   {
;     454 	   Beeper=1;
	SBI  0x12,3
;     455 	   delay_us(300);
	__DELAY_USW 600
;     456 	   Beeper=0; 
	RCALL SUBOPT_0x1C
;     457 	   delay_us(150);	   
;     458 	   }    
	RCALL SUBOPT_0x5
	RJMP _0x3A
_0x3B:
;     459  
;     460 RFOut=0; 
	CBI  0x12,2
;     461 RFstate = TRFSYNC;
	RCALL SUBOPT_0xD
;     462 //Switch = 0; 
;     463 }
	RET
;     464 
;     465 
;     466 //***************************************************************
;     467 
;     468 //BackGroundRecive
;     469 //interrupt [TIM0_OVF] void timer0_ovf_isr(void)
;     470 interrupt [TIM1_OVF] void timer1_ovf_isr(void)
;     471 {          
_timer1_ovf_isr:
	RCALL SUBOPT_0x1D
;     472 BGRXcnt++;
	MOVW R30,R6
	ADIW R30,1
	MOVW R6,R30
;     473 
;     474 
;     475 switch(BGRX)
	MOV  R30,R14
;     476       {
;     477 //#######################################################################################################################
;     478 //##############################################     ##################################################
;     479 //#######################################################################################################################
;     480 
;     481       case BGRX_Run:
	CPI  R30,LOW(0x1)
	BREQ PC+2
	RJMP _0x3F
;     482 
;     483 	   if ( BGRXcnt == 8) // Optimal read-point for MASTER reciver  7,  10
	LDI  R30,LOW(8)
	LDI  R31,HIGH(8)
	RCALL SUBOPT_0x1E
	BRNE _0x40
;     484 	      {
;     485 //	      TETest=0; //              !!!
;     486 	      
;     487 	      if (RFFull == 0)
	SBRC R2,1
	RJMP _0x41
;     488                  RxBuf[BitCount]=RFInM;     //   1/3 ,        
	RCALL SUBOPT_0x1F
	RCALL SUBOPT_0x20
	SUBI R26,LOW(-_RxBuf)
	SBCI R27,HIGH(-_RxBuf)
	LDI  R30,0
	SBIC 0x13,5
	LDI  R30,1
	ST   X,R30
;     489 
;     490                  if (BitCount == 5 || BitCount == 10 || BitCount == 15 || BitCount == 20 || BitCount == 25 || BitCount == 30 || BitCount == 35 || BitCount == 40 || BitCount == 45)
_0x41:
	RCALL SUBOPT_0x1F
	CPI  R26,LOW(0x5)
	BREQ _0x43
	RCALL SUBOPT_0x1F
	CPI  R26,LOW(0xA)
	BREQ _0x43
	RCALL SUBOPT_0x1F
	CPI  R26,LOW(0xF)
	BREQ _0x43
	RCALL SUBOPT_0x1F
	CPI  R26,LOW(0x14)
	BREQ _0x43
	RCALL SUBOPT_0x1F
	CPI  R26,LOW(0x19)
	BREQ _0x43
	RCALL SUBOPT_0x1F
	CPI  R26,LOW(0x1E)
	BREQ _0x43
	RCALL SUBOPT_0x1F
	CPI  R26,LOW(0x23)
	BREQ _0x43
	RCALL SUBOPT_0x1F
	CPI  R26,LOW(0x28)
	BREQ _0x43
	RCALL SUBOPT_0x1F
	CPI  R26,LOW(0x2D)
	BRNE _0x42
_0x43:
;     491                  //if (L3FErCNT >= 5 && BitCount > 5)
;     492                     { 
;     493                     //L3FErCNT=0;
;     494                     //Switch = 1;
;     495                     RFOut=1;
	SBI  0x12,2
;     496                     }
;     497 
;     498 	      ++BitCount;
_0x42:
	LDS  R30,_BitCount
	SUBI R30,-LOW(1)
	STS  _BitCount,R30
;     499 	      //++L3FErCNT;
;     500 
;     501               if (BitCount == 63) //   -
	RCALL SUBOPT_0x1F
	CPI  R26,LOW(0x3F)
	BRNE _0x45
;     502          	 {
;     503          	 //Switch = 1;
;     504 //       	 Vibro=0;
;     505          	 RxBuf[63]=1;
	LDI  R30,LOW(1)
	__PUTB1MN _RxBuf,63
;     506                  LastRxCnt=0;	      //    
	CLR  R8
	CLR  R9
;     507                  TXFlag  = 1;
	SET
	BLD  R2,2
;     508 
;     509   		 if (RFFull == 0)   //     
	SBRS R2,1
;     510  	            SetActive();      //  
	RCALL _SetActive
;     511 
;     512          	 LedR=1;
	SBI  0x15,0
;     513                  BGRX    = BGRX_Wait; //   
	CLR  R14
;     514    		 RFstate = TRFSYNC;
	RCALL SUBOPT_0xD
;     515         	 RFError();
	RCALL _RFError
;     516 //   		 Vibro=1;
;     517 
;     518 		 break;
	RJMP _0x3E
;     519     	         }
;     520 	      }
_0x45:
;     521 
;     522 if ( BGRXcnt == 13)
_0x40:
	LDI  R30,LOW(13)
	LDI  R31,HIGH(13)
	RCALL SUBOPT_0x1E
	BRNE _0x47
;     523    {
;     524    RFOut=0;
	CBI  0x12,2
;     525    //Switch = 0;
;     526    }
;     527 
;     528 
;     529 	   if (BGRXcnt == 15) // 13      16 //     
_0x47:
	LDI  R30,LOW(15)
	LDI  R31,HIGH(15)
	RCALL SUBOPT_0x1E
	BRNE _0x48
;     530 	      {              
;     531 	      if (RFInM == 1 && BitCount < 5)
	SBIS 0x13,5
	RJMP _0x4A
	RCALL SUBOPT_0x1F
	CPI  R26,LOW(0x5)
	BRLO _0x4B
_0x4A:
	RJMP _0x49
_0x4B:
;     532 	         {
;     533 	         //RFstate = TRFSYNC;
;     534 	         BGRX    = BGRX_Wait;
	CLR  R14
;     535 	         RFstate = TRFError;
	LDI  R30,LOW(3)
	RCALL SUBOPT_0x8
;     536 	         }
;     537 	      
;     538   	      //RFcount = 0;
;     539 	      BGRX    = BGRX_Zero; //
_0x49:
	LDI  R30,LOW(2)
	MOV  R14,R30
;     540 	      }
;     541 
;     542 //          }      
;     543 
;     544       break;
_0x48:
	RJMP _0x3E
;     545      
;     546      
;     547 //********************************************************************
;     548 
;     549       case BGRX_Wait:
_0x3F:
	CPI  R30,0
	BREQ _0x3E
;     550       
;     551       
;     552       break;
;     553            
;     554 //********************************************************************
;     555 
;     556       case BGRX_Zero:  
	CPI  R30,LOW(0x2)
	BRNE _0x4E
;     557       default:
_0x4E:
;     558  
;     559  if (RFInM == 1) //   
	SBIS 0x13,5
	RJMP _0x4F
;     560     {
;     561 //    TETest=1;                  //           !!!
;     562     
;     563      // rising edge detected     +----
;     564      //                          |
;     565      //                      ----+     
;     566      BGRXcnt = 0;     
	CLR  R6
	CLR  R7
;     567      //RFcount = 0;                // reset length count                  
;     568      BGRX    = BGRX_Run; 
	LDI  R30,LOW(1)
	MOV  R14,R30
;     569      break;        	             	         
	RJMP _0x3E
;     570      } 
;     571   
;     572     if (BGRXcnt > 35) //     10
_0x4F:
	LDI  R30,LOW(35)
	LDI  R31,HIGH(35)
	RCALL SUBOPT_0x1E
	BRGE _0x50
;     573        {       
;     574        //RFcount=0;                          
;     575        BGRX   = BGRX_Wait; 
	CLR  R14
;     576        //RFstate = TRFSYNC;      
;     577        RFstate = TRFError; // 
	LDI  R30,LOW(3)
	RCALL SUBOPT_0x8
;     578        }     
;     579   
;     580       break;
_0x50:
;     581 
;     582       }                                                      
_0x3E:
;     583 }                     
	RCALL SUBOPT_0x21
	RETI
;     584 
;     585 
;     586 #include "control.c"//  -    ...
;     587 //------------------- 
;     588 void Beep2(void)
;     589 {        
_Beep2:
;     590 //Switch = 1; 
;     591 LedR=1;    
	SBI  0x15,0
;     592 //Vibro=0;
;     593 RFOut=1;
	SBI  0x12,2
;     594 
;     595 for(i = 0; i != 250; i++)
	RCALL SUBOPT_0x6
_0x52:
	RCALL SUBOPT_0x1
	CPI  R26,LOW(0xFA)
	BREQ _0x53
;     596    {
;     597    Beeper=1;
	SBI  0x12,3
;     598    delay_us(150);
	__DELAY_USW 300
;     599    Beeper=0;
	RCALL SUBOPT_0x1C
;     600    delay_us(150);
;     601    }  
	RCALL SUBOPT_0x5
	RJMP _0x52
_0x53:
;     602 LedR=0;   
	CBI  0x15,0
;     603 for(i = 0; i != 200; i++)
	RCALL SUBOPT_0x6
_0x55:
	RCALL SUBOPT_0x1
	CPI  R26,LOW(0xC8)
	BREQ _0x56
;     604    {
;     605    Beeper=1;
	SBI  0x12,3
;     606    delay_us(250);
	RCALL SUBOPT_0x22
;     607    Beeper=0;
	CBI  0x12,3
;     608    delay_us(250);
	RCALL SUBOPT_0x22
;     609    }   
	RCALL SUBOPT_0x5
	RJMP _0x55
_0x56:
;     610 LedR=1;   
	SBI  0x15,0
;     611 for(i = 0; i != 150; i++)
	RCALL SUBOPT_0x6
_0x58:
	RCALL SUBOPT_0x1
	CPI  R26,LOW(0x96)
	BREQ _0x59
;     612    {
;     613    Beeper=1;
	SBI  0x12,3
;     614    delay_us(350);
	RCALL SUBOPT_0x23
;     615    Beeper=0;
	CBI  0x12,3
;     616    delay_us(350);
	RCALL SUBOPT_0x23
;     617    }   
	RCALL SUBOPT_0x5
	RJMP _0x58
_0x59:
;     618 
;     619 RFOut=0;      
	CBI  0x12,2
;     620 //Vibro=1;   
;     621 LedR=0;
	CBI  0x15,0
;     622 //Switch = 0; 
;     623 }
	RET
;     624 
;     625 //************************************************************************************************
;     626 
;     627 void RWCell(byte M)
;     628 {
_RWCell:
;     629 switch (CellNo)
;	M -> Y+0
	LDS  R30,_CellNo
;     630        {       
;     631 //-------------------------------------       
;     632 	    case Cell_0:
	CPI  R30,0
	BRNE _0x5D
;     633 		     for (i = 0; i != 66; i ++)
	RCALL SUBOPT_0x6
_0x5F:
	RCALL SUBOPT_0xB
	BREQ _0x60
;     634 		         {
;     635 		         if (M==R)
	RCALL SUBOPT_0x24
	BRNE _0x61
;     636   		            RxBuf[i]   = EprBuf0[i];				                  		        
	RCALL SUBOPT_0x7
	RCALL SUBOPT_0x25
	RCALL SUBOPT_0x26
	SUBI R26,LOW(-_EprBuf0)
	SBCI R27,HIGH(-_EprBuf0)
	RCALL SUBOPT_0x27
;     637 		        else   
	RJMP _0x62
_0x61:
;     638 		            EprBuf0[i] = RxBuf[i];
	RCALL SUBOPT_0x28
	SUBI R26,LOW(-_EprBuf0)
	SBCI R27,HIGH(-_EprBuf0)
	RCALL SUBOPT_0x7
	RCALL SUBOPT_0x29
;     639 		         }
_0x62:
	RCALL SUBOPT_0x5
	RJMP _0x5F
_0x60:
;     640         break;
	RJMP _0x5C
;     641 //------------------------------------- 
;     642 	    case Cell_1:
_0x5D:
	CPI  R30,LOW(0x1)
	BRNE _0x63
;     643 		     for (i = 0; i != 66; i ++)
	RCALL SUBOPT_0x6
_0x65:
	RCALL SUBOPT_0xB
	BREQ _0x66
;     644 		         {
;     645 		         if (M==R)
	RCALL SUBOPT_0x24
	BRNE _0x67
;     646   		            RxBuf[i]   = EprBuf1[i];				                  		        
	RCALL SUBOPT_0x7
	RCALL SUBOPT_0x25
	RCALL SUBOPT_0x26
	SUBI R26,LOW(-_EprBuf1)
	SBCI R27,HIGH(-_EprBuf1)
	RCALL SUBOPT_0x27
;     647 		        else   
	RJMP _0x68
_0x67:
;     648 		            EprBuf1[i] = RxBuf[i];
	RCALL SUBOPT_0x28
	SUBI R26,LOW(-_EprBuf1)
	SBCI R27,HIGH(-_EprBuf1)
	RCALL SUBOPT_0x7
	RCALL SUBOPT_0x29
;     649 		         }
_0x68:
	RCALL SUBOPT_0x5
	RJMP _0x65
_0x66:
;     650 		break;
	RJMP _0x5C
;     651 //------------------------------------- 
;     652 		case Cell_2:
_0x63:
	CPI  R30,LOW(0x2)
	BRNE _0x5C
;     653 		     for (i = 0; i != 66; i ++)
	RCALL SUBOPT_0x6
_0x6B:
	RCALL SUBOPT_0xB
	BREQ _0x6C
;     654 		         {
;     655 		         if (M==R)
	RCALL SUBOPT_0x24
	BRNE _0x6D
;     656   		            RxBuf[i]   = EprBuf2[i];				                  		        
	RCALL SUBOPT_0x7
	RCALL SUBOPT_0x25
	RCALL SUBOPT_0x26
	SUBI R26,LOW(-_EprBuf2)
	SBCI R27,HIGH(-_EprBuf2)
	RCALL SUBOPT_0x27
;     657 		        else   
	RJMP _0x6E
_0x6D:
;     658 		            EprBuf2[i] = RxBuf[i];
	RCALL SUBOPT_0x28
	SUBI R26,LOW(-_EprBuf2)
	SBCI R27,HIGH(-_EprBuf2)
	RCALL SUBOPT_0x7
	RCALL SUBOPT_0x29
;     659 		         } 
_0x6E:
	RCALL SUBOPT_0x5
	RJMP _0x6B
_0x6C:
;     660 		break;
;     661 //-------------------------------------		
;     662 	   }  
_0x5C:
;     663 	   	   
;     664 if (M==R) //     > RAM
	RCALL SUBOPT_0x24
	BRNE _0x6F
;     665    {
;     666    TX(RxBuf);
	RCALL SUBOPT_0x16
;     667    delay_ms(100);
	RCALL SUBOPT_0x2A
;     668    TX(RxBuf);
	RCALL SUBOPT_0x16
;     669    }
;     670 else         
	RJMP _0x70
_0x6F:
;     671    {
;     672    *RxBuf=0;
	LDI  R30,LOW(0)
	STS  _RxBuf,R30
;     673    *RxBuf1=0;
	STS  _RxBuf1,R30
;     674    *RxBuf2=0;
	STS  _RxBuf2,R30
;     675    }
_0x70:
;     676     
;     677 Beep2();   
	RCALL _Beep2
;     678 }
	ADIW R28,1
	RET
;     679 
;     680 //************************************************************************************************
;     681 
;     682 void Cell_Select(void)
;     683 {         
_Cell_Select:
;     684 Beep();
	RCALL _Beep
;     685 
;     686 if (CellNo == Cell_0)
	LDS  R30,_CellNo
	CPI  R30,0
	BRNE _0x71
;     687    {
;     688    CellNo   = Cell_1;
	LDI  R30,LOW(1)
	STS  _CellNo,R30
;     689    delay_ms(100);
	RCALL SUBOPT_0x2A
;     690    Beep();   
	RCALL _Beep
;     691    return;
	RET
;     692    }
;     693 
;     694 if (CellNo == Cell_1)
_0x71:
	LDS  R26,_CellNo
	CPI  R26,LOW(0x1)
	BRNE _0x72
;     695    {
;     696    CellNo   = Cell_2;
	LDI  R30,LOW(2)
	STS  _CellNo,R30
;     697    delay_ms(100);
	RCALL SUBOPT_0x2A
;     698    Beep();           
	RCALL _Beep
;     699    delay_ms(100);
	RCALL SUBOPT_0x2A
;     700    Beep();
	RCALL _Beep
;     701    return;
	RET
;     702    }
;     703 
;     704 if (CellNo == Cell_2)
_0x72:
	LDS  R26,_CellNo
	CPI  R26,LOW(0x2)
	BRNE _0x73
;     705    {
;     706    CellNo   = Cell_0;
	LDI  R30,LOW(0)
	STS  _CellNo,R30
;     707    return;
	RET
;     708    }
;     709       
;     710 }
_0x73:
	RET
;     711 
;     712 
;     713 //************************************************************************************************
;     714 //--------------------  ,      =)         
;     715 void Beep(void)
;     716 {          
_Beep:
;     717 //Switch = 1; 
;     718 RFOut=1;
	SBI  0x12,2
;     719 
;     720 //if (ring!=1)
;     721 	for(i = 0; i != 100; i++)
	RCALL SUBOPT_0x6
_0x75:
	RCALL SUBOPT_0x1
	CPI  R26,LOW(0x64)
	BREQ _0x76
;     722 	   {
;     723 	   Beeper=1;
	SBI  0x12,3
;     724 	   delay_us(200);
	__DELAY_USW 400
;     725 	   Beeper=0; 
	RCALL SUBOPT_0x1C
;     726 	   delay_us(150);	   
;     727 	   }    
	RCALL SUBOPT_0x5
	RJMP _0x75
_0x76:
;     728 /*else
;     729    {	   
;     730    Vibro=0;   
;     731    delay_ms(100);
;     732    Vibro=1;   
;     733    }*/
;     734  
;     735 RFOut=0; 
	CBI  0x12,2
;     736 //Switch = 0; 
;     737 }                                                                                                 
	RET
;     738 
;     739 interrupt [TIM2_OVF] void timer2_ovf_isr(void)
;     740 {            
_timer2_ovf_isr:
	RCALL SUBOPT_0x1D
;     741 LastRxCnt++; 
	MOVW R30,R8
	ADIW R30,1
	MOVW R8,R30
;     742 LedPulse++;          
	MOVW R30,R10
	ADIW R30,1
	MOVW R10,R30
;     743 
;     744 if (LastRxCnt > 6000) //     50ms
	LDI  R30,LOW(6000)
	LDI  R31,HIGH(6000)
	CP   R30,R8
	CPC  R31,R9
	BRGE _0x77
;     745    {
;     746    LastRxCnt=0;  
	CLR  R8
	CLR  R9
;     747    if (TXFlag)
	SBRS R2,2
	RJMP _0x78
;     748       { 
;     749       begin++;     
	LDS  R30,_begin
	SUBI R30,-LOW(1)
	RCALL SUBOPT_0x2B
;     750       BTNcomp(); //            	 
	RCALL _BTNcomp
;     751 //      Vibro=1;    
;     752       LedR=0;   
	CBI  0x15,0
;     753       RFFull=0;
	CLT
	BLD  R2,1
;     754       TXFlag=0;
	BLD  R2,2
;     755       Beep();
	RCALL _Beep
;     756       }                    
;     757    }                 
_0x78:
;     758    
;     759        
;     760 
;     761 //****   
;     762 
;     763 if ( LedPulse>3000)
_0x77:
	LDI  R30,LOW(3000)
	LDI  R31,HIGH(3000)
	CP   R30,R10
	CPC  R31,R11
	BRGE _0x79
;     764    {    
;     765    if (Grab != 1)   
	RCALL SUBOPT_0x15
	BREQ _0x7A
;     766        LedG  = 1;
	SBI  0x15,1
;     767       
;     768  /*  LedM1 = 1;
;     769    LedM2 = 1;
;     770    LedM3 = 1;  */
;     771    }        
_0x7A:
;     772    
;     773 if ( LedPulse>4000)
_0x79:
	LDI  R30,LOW(4000)
	LDI  R31,HIGH(4000)
	CP   R30,R10
	CPC  R31,R11
	BRGE _0x7B
;     774    {   
;     775 	if (Grab < 2)   
	RCALL SUBOPT_0xE
	CPI  R26,LOW(0x2)
	BRSH _0x7C
;     776 	    LedG  = 0;    
	CBI  0x15,1
;     777 	          
;     778        /*	if (CellNo != Cell_0)   
;     779 	    LedM1 = 0;   
;     780 	if (CellNo != Cell_1)   
;     781 	    LedM2 = 0;   
;     782 	if (CellNo != Cell_2)   
;     783 	    LedM3 = 0;     */
;     784    
;     785 	   LedPulse=0;
_0x7C:
	CLR  R10
	CLR  R11
;     786    } 
;     787                              
;     788 //+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
;     789 //byte GrabTMP;
;     790 //int BtnTime;             
;     791 //************************************************************************************************
;     792 //---------------------------------------------------------------- 
;     793 if (BtnTx==0) 
_0x7B:
	SBIS 0x13,3
;     794     delay_ms(50);
	RCALL SUBOPT_0x2C
;     795 
;     796  if (BtnTx==0) 
	SBIC 0x13,3
	RJMP _0x7E
;     797     {             
;     798     delay_ms(200);
	RCALL SUBOPT_0x2D
;     799     LedR=1;
	SBI  0x15,0
;     800     if (BtnTx==1)//  50ms 
	SBIS 0x13,3
	RJMP _0x7F
;     801        {                
;     802        begin=0;    
	LDI  R30,LOW(0)
	RCALL SUBOPT_0x2B
;     803        if (Grab==1)
	RCALL SUBOPT_0x15
	BRNE _0x80
;     804           {
;     805           RFFull=1;   
	SET
	BLD  R2,1
;     806           begin=0;
	LDI  R30,LOW(0)
	RCALL SUBOPT_0x2B
;     807           SetActive();  //  
	RCALL _SetActive
;     808           BTNcomp();    //  RAM         
	RCALL _BTNcomp
;     809           }           
;     810       else             
	RJMP _0x81
_0x80:
;     811           {
;     812           Grab=0;                                    
	LDI  R30,LOW(0)
	RCALL SUBOPT_0x10
;     813           TX(RxBufLox); //  RAM                           
	RCALL SUBOPT_0xF
	RCALL _TX
;     814           delay_ms(200);          
	RCALL SUBOPT_0x2D
;     815           TX(RxBufLox);                          
	RCALL SUBOPT_0xF
	RCALL _TX
;     816 //          LedG=0;                  
;     817           }
_0x81:
;     818        }   
;     819    else
	RJMP _0x82
_0x7F:
;     820        {
;     821        delay_ms(500);
	RCALL SUBOPT_0x2E
;     822        if (BtnTx==0)//  300ms  
	SBIC 0x13,3
	RJMP _0x83
;     823           {
;     824           RWCell(R);  //    EEPROM
	LDI  R30,LOW(1)
	ST   -Y,R30
	RCALL _RWCell
;     825           Cell_Select();
	RCALL _Cell_Select
;     826           }
;     827        }
_0x83:
_0x82:
;     828     LedR=0;        
	CBI  0x15,0
;     829     
;     830     while (BtnTx==0) //   
_0x84:
	SBIC 0x13,3
	RJMP _0x86
;     831           {
;     832           delay_ms(10);                               
	RCALL SUBOPT_0xC
	RCALL SUBOPT_0xA
;     833           }    
	RJMP _0x84
_0x86:
;     834     }
;     835         
;     836 //----------------------------------------------------------------                   
;     837 
;     838 if (BtnMem==0) 
_0x7E:
	SBIS 0x13,4
;     839     delay_ms(50);
	RCALL SUBOPT_0x2C
;     840 
;     841  if (BtnMem==0)  //   ""
	SBIC 0x13,4
	RJMP _0x88
;     842     {           
;     843 //    BtnTime++;    
;     844     delay_ms(200);
	RCALL SUBOPT_0x2D
;     845     if (BtnMem==1)//  50ms 
	SBIS 0x13,4
	RJMP _0x89
;     846        {
;     847        Cell_Select();            // 
	RCALL _Cell_Select
;     848        }
;     849     else
	RJMP _0x8A
_0x89:
;     850         {
;     851         delay_ms(500);
	RCALL SUBOPT_0x2E
;     852         if (BtnMem==0)//  300ms   
	SBIC 0x13,4
	RJMP _0x8B
;     853            {                                                                
;     854            begin=0; 
	LDI  R30,LOW(0)
	RCALL SUBOPT_0x2B
;     855                                                 
;     856            if (Grab>1)
	RCALL SUBOPT_0xE
	CPI  R26,LOW(0x2)
	BRLO _0x8C
;     857               {       
;     858               memcpy(RxBuf,RxBufLox, 65); //   LOX-                                          
	RCALL SUBOPT_0x1A
	RCALL SUBOPT_0xF
	RCALL SUBOPT_0x1B
;     859               Grab=0;
	LDI  R30,LOW(0)
	RCALL SUBOPT_0x10
;     860               LedG=0;
	CBI  0x15,1
;     861               }
;     862           else 
	RJMP _0x8D
_0x8C:
;     863               {            
;     864               SetActive();
	RCALL _SetActive
;     865               RFFull = 0;                             
	CLT
	BLD  R2,1
;     866               }
_0x8D:
;     867                                                                                                                       
;     868            RWCell(W);             //   RxBuf-                                 
	LDI  R30,LOW(0)
	ST   -Y,R30
	RCALL _RWCell
;     869            Cell_Select();
	RCALL _Cell_Select
;     870            
;     871   	       for (i = 0; i != 66; i ++)
	RCALL SUBOPT_0x6
_0x8F:
	RCALL SUBOPT_0xB
	BREQ _0x90
;     872 		         {		         
;     873   		         RxBuf [i] = 0;
	RCALL SUBOPT_0x28
	SUBI R26,LOW(-_RxBuf)
	SBCI R27,HIGH(-_RxBuf)
	LDI  R30,LOW(0)
	ST   X,R30
;     874   		         RxBuf1[i] = 0;
	RCALL SUBOPT_0x28
	SUBI R26,LOW(-_RxBuf1)
	SBCI R27,HIGH(-_RxBuf1)
	LDI  R30,LOW(0)
	ST   X,R30
;     875   		         RxBuf2[i] = 0;
	RCALL SUBOPT_0x28
	SUBI R26,LOW(-_RxBuf2)
	SBCI R27,HIGH(-_RxBuf2)
	LDI  R30,LOW(0)
	ST   X,R30
;     876 		         }
	RCALL SUBOPT_0x5
	RJMP _0x8F
_0x90:
;     877                                  
;     878            }  
;     879            
;     880     while (BtnMem==0) //   
_0x8B:
_0x91:
	SBIC 0x13,4
	RJMP _0x93
;     881           {
;     882           delay_ms(10);
	RCALL SUBOPT_0xC
	RCALL SUBOPT_0xA
;     883           }           
	RJMP _0x91
_0x93:
;     884         }
_0x8A:
;     885    }    
;     886   
;     887 //----------------------------------------------------------------  /             
;     888 
;     889 if (BtnMode==0) 
_0x88:
	SBIS 0x13,2
;     890     delay_ms(50);
	RCALL SUBOPT_0x2C
;     891 
;     892  if (BtnMode==0)  //   ""
	SBIC 0x13,2
	RJMP _0x95
;     893     {           
;     894 //    BtnTime++;    
;     895     delay_ms(200);    
	RCALL SUBOPT_0x2D
;     896     LedR=1;                
	SBI  0x15,0
;     897     if (BtnMode==1)//  50ms 
	SBIS 0x13,2
	RJMP _0x96
;     898        {       
;     899        if (Grab != 1)//    
	RCALL SUBOPT_0x15
	BREQ _0x97
;     900            Grab=1;
	LDI  R30,LOW(1)
	RJMP _0xA5
;     901        else       
_0x97:
;     902            Grab=0;
	LDI  R30,LOW(0)
_0xA5:
	STS  _Grab,R30
;     903            
;     904        Beep();    
	RJMP _0xA6
;     905        }
;     906    else 
_0x96:
;     907        {          
;     908        LedR=1;
	SBI  0x15,0
;     909        delay_ms(500);
	RCALL SUBOPT_0x2E
;     910        if (BtnMode==0)//  300ms   
	SBIC 0x13,2
	RJMP _0x9A
;     911           {                                         
;     912 /*          ring=eep_ring;
;     913           
;     914           if (ring)    
;     915              ring=0;                   
;     916           else
;     917              ring=1;
;     918              
;     919           eep_ring=ring;   */
;     920                     
;     921            Beep();
	RCALL _Beep
;     922            Beep();
_0xA6:
	RCALL _Beep
;     923           }                 
;     924        }           
_0x9A:
;     925     
;     926     LedR=0;                        
	CBI  0x15,0
;     927     while (BtnMode==0) //   
_0x9B:
	SBIC 0x13,2
	RJMP _0x9D
;     928           {
;     929           delay_ms(10);
	RCALL SUBOPT_0xC
	RCALL SUBOPT_0xA
;     930           }           
	RJMP _0x9B
_0x9D:
;     931 
;     932    }                   
;     933 //+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
;     934 
;     935 }
_0x95:
	RCALL SUBOPT_0x21
	RETI
;     936 
;     937 
;     938 
;     939 
;     940 // Declare your global variables here
;     941 
;     942 
;     943 // Declare your global variables here
;     944 
;     945 void main(void)
;     946 {
_main:
;     947 // Declare your local variables here
;     948 
;     949 // Input/Output Ports initialization
;     950 // Port B initialization
;     951 // Func0=In Func1=In Func2=In Func3=Out Func4=In Func5=Out Func6=In Func7=In
;     952 // State0=P State1=P State2=P State3=0 State4=T State5=0 State6=T State7=T
;     953 PORTB=0x07;
	LDI  R30,LOW(7)
	OUT  0x18,R30
;     954 DDRB=0x28;
	LDI  R30,LOW(40)
	OUT  0x17,R30
;     955 
;     956 // Port C initialization
;     957 // Func0=Out Func1=Out Func2=In Func3=In Func4=In Func5=In Func6=In
;     958 // State0=0 State1=0 State2=P State3=P State4=P State5=T State6=T
;     959 PORTC=0x1C;
	LDI  R30,LOW(28)
	OUT  0x15,R30
;     960 DDRC=0x03;
	LDI  R30,LOW(3)
	OUT  0x14,R30
;     961 
;     962 // Port D initialization
;     963 // Func0=Out Func1=Out Func2=Out Func3=Out Func4=In Func5=In Func6=In Func7=In
;     964 // State0=0 State1=0 State2=0 State3=0 State4=T State5=T State6=T State7=T
;     965 PORTD=0x00;
	LDI  R30,LOW(0)
	OUT  0x12,R30
;     966 DDRD=0x0F;
	LDI  R30,LOW(15)
	OUT  0x11,R30
;     967 
;     968 // Timer/Counter 0 initialization
;     969 // Clock source: System Clock
;     970 // Clock value: 1000,000 kHz
;     971 TCCR0=0x02;
	LDI  R30,LOW(2)
	OUT  0x33,R30
;     972 TCNT0=0x00;
	LDI  R30,LOW(0)
	OUT  0x32,R30
;     973 
;     974 // Timer/Counter 1 initialization
;     975 // Clock source: System Clock
;     976 // Clock value: 8000,000 kHz
;     977 // Mode: Ph. correct PWM top=00FFh
;     978 // OC1A output: Discon.
;     979 // OC1B output: Discon.
;     980 // Noise Canceler: Off
;     981 // Input Capture on Falling Edge
;     982 TCCR1A=0x01;
	LDI  R30,LOW(1)
	OUT  0x2F,R30
;     983 TCCR1B=0x01;
	OUT  0x2E,R30
;     984 TCNT1H=0x00;
	LDI  R30,LOW(0)
	OUT  0x2D,R30
;     985 TCNT1L=0x00;
	OUT  0x2C,R30
;     986 OCR1AH=0x00;
	OUT  0x2B,R30
;     987 OCR1AL=0x00;
	OUT  0x2A,R30
;     988 OCR1BH=0x00;
	OUT  0x29,R30
;     989 OCR1BL=0x00;
	OUT  0x28,R30
;     990 
;     991 // Timer/Counter 2 initialization
;     992 // Clock source: System Clock
;     993 // Clock value: 8000,000 kHz
;     994 // Mode: Normal top=FFh
;     995 // OC2 output: Disconnected
;     996 ASSR=0x00;
	OUT  0x22,R30
;     997 TCCR2=0x01;
	LDI  R30,LOW(1)
	OUT  0x25,R30
;     998 TCNT2=0x00;
	LDI  R30,LOW(0)
	OUT  0x24,R30
;     999 OCR2=0x00;
	OUT  0x23,R30
;    1000 
;    1001 // External Interrupt(s) initialization
;    1002 // INT0: Off
;    1003 // INT1: Off
;    1004 GICR|=0x00;
	IN   R30,0x3B
	OUT  0x3B,R30
;    1005 MCUCR=0x00;
	LDI  R30,LOW(0)
	OUT  0x35,R30
;    1006 
;    1007 // Timer(s)/Counter(s) Interrupt(s) initialization
;    1008 TIMSK=0x45;
	LDI  R30,LOW(69)
	OUT  0x39,R30
;    1009 
;    1010 // Analog Comparator initialization
;    1011 // Analog Comparator: Off
;    1012 // Analog Comparator Input Capture by Timer/Counter 1: Off
;    1013 // Analog Comparator Output: Off
;    1014 ACSR=0x80;
	LDI  R30,LOW(128)
	OUT  0x8,R30
;    1015 SFIOR=0x00;
	LDI  R30,LOW(0)
	OUT  0x30,R30
;    1016 
;    1017 		      LedR = 1;        //  
	SBI  0x15,0
;    1018 		      LedG = 1;
	SBI  0x15,1
;    1019 //****
;    1020 /* if (BtnMode==0)  //   ""
;    1021     {             
;    1022     delay_ms(500);
;    1023     if (BtnMode==0)//  300ms   
;    1024        {                                         */
;    1025       
;    1026 		for(i = 0; i != 10; i++)
	RCALL SUBOPT_0x6
_0x9F:
	RCALL SUBOPT_0x1
	CPI  R26,LOW(0xA)
	BREQ _0xA0
;    1027 		      {      
;    1028 		      LedR = 1;        //  
	SBI  0x15,0
;    1029 		      LedG = 0;
	CBI  0x15,1
;    1030 		      delay_ms(50);    //  50ms
	RCALL SUBOPT_0x2C
;    1031 			  LedR = 0;        //s        
	CBI  0x15,0
;    1032 			  LedG = 1;
	SBI  0x15,1
;    1033 		      delay_ms(50);    //  50ms      
	RCALL SUBOPT_0x2C
;    1034 		      }                                       
	RCALL SUBOPT_0x5
	RJMP _0x9F
_0xA0:
;    1035 		      LedG = 0;
	CBI  0x15,1
;    1036 		      Beep2();            
	RCALL _Beep2
;    1037 		
;    1038 		Grab=1;//          
	LDI  R30,LOW(1)
	RCALL SUBOPT_0x10
;    1039 //		ring=eep_ring;
;    1040 
;    1041 /*                 
;    1042 Switch= 1;                              
;    1043  while (1)       //     
;    1044        {                
;    1045        RFOut=1;
;    1046        delay_ms(1);
;    1047        RFOut=0;
;    1048        delay_ms(1);
;    1049        }		
;    1050 */		
;    1051 		// Global enable interrupts
;    1052 		#asm("sei")  
	sei
;    1053   //     }               
;    1054    // }  
;    1055 
;    1056 //***          
;    1057 
;    1058 
;    1059 
;    1060 
;    1061 }
_0xA1:
	RJMP _0xA1

_getchar:
     sbis usr,rxc
     rjmp _getchar
     in   r30,udr
	RET
_putchar:
     sbis usr,udre
     rjmp _putchar
     ld   r30,y
     out  udr,r30
	ADIW R28,1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 30 TIMES, CODE SIZE REDUCTION:27 WORDS
SUBOPT_0x0:
	STS  _i,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 24 TIMES, CODE SIZE REDUCTION:21 WORDS
SUBOPT_0x1:
	LDS  R26,_i
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 28 TIMES, CODE SIZE REDUCTION:25 WORDS
SUBOPT_0x2:
	LDS  R30,_i
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 13 TIMES, CODE SIZE REDUCTION:22 WORDS
SUBOPT_0x3:
	LDI  R31,0
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:18 WORDS
SUBOPT_0x4:
	SUBI R30,LOW(-_RxBuf)
	SBCI R31,HIGH(-_RxBuf)
	LD   R0,Z
	RCALL SUBOPT_0x2
	LDD  R26,Y+1
	LDD  R27,Y+1+1
	RCALL SUBOPT_0x3
	ADD  R26,R30
	ADC  R27,R31
	LD   R30,X
	CP   R30,R0
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 15 TIMES, CODE SIZE REDUCTION:26 WORDS
SUBOPT_0x5:
	RCALL SUBOPT_0x2
	SUBI R30,-LOW(1)
	RJMP SUBOPT_0x0

;OPTIMIZER ADDED SUBROUTINE, CALLED 13 TIMES, CODE SIZE REDUCTION:10 WORDS
SUBOPT_0x6:
	LDI  R30,LOW(0)
	RJMP SUBOPT_0x0

;OPTIMIZER ADDED SUBROUTINE, CALLED 7 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0x7:
	RCALL SUBOPT_0x2
	RJMP SUBOPT_0x3

;OPTIMIZER ADDED SUBROUTINE, CALLED 12 TIMES, CODE SIZE REDUCTION:9 WORDS
SUBOPT_0x8:
	STS  _RFstate,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:10 WORDS
SUBOPT_0x9:
	__DELAY_USW 800
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 21 TIMES, CODE SIZE REDUCTION:38 WORDS
SUBOPT_0xA:
	ST   -Y,R31
	ST   -Y,R30
	RJMP _delay_ms

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0xB:
	RCALL SUBOPT_0x1
	CPI  R26,LOW(0x42)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0xC:
	LDI  R30,LOW(10)
	LDI  R31,HIGH(10)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0xD:
	LDI  R30,LOW(0)
	RJMP SUBOPT_0x8

;OPTIMIZER ADDED SUBROUTINE, CALLED 10 TIMES, CODE SIZE REDUCTION:7 WORDS
SUBOPT_0xE:
	LDS  R26,_Grab
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:10 WORDS
SUBOPT_0xF:
	LDI  R30,LOW(_RxBufLox)
	LDI  R31,HIGH(_RxBufLox)
	ST   -Y,R31
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x10:
	STS  _Grab,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x11:
	SET
	BLD  R2,0
	LDI  R30,LOW(_RxBuf2)
	LDI  R31,HIGH(_RxBuf2)
	ST   -Y,R31
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x12:
	LDI  R30,LOW(_RxBuf2)
	LDI  R31,HIGH(_RxBuf2)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x13:
	CLT
	BLD  R2,0
	LDI  R30,LOW(_RxBuf1)
	LDI  R31,HIGH(_RxBuf1)
	ST   -Y,R31
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x14:
	LDI  R30,LOW(_RxBuf1)
	LDI  R31,HIGH(_RxBuf1)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x15:
	RCALL SUBOPT_0xE
	CPI  R26,LOW(0x1)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:10 WORDS
SUBOPT_0x16:
	LDI  R30,LOW(_RxBuf)
	LDI  R31,HIGH(_RxBuf)
	ST   -Y,R31
	ST   -Y,R30
	RJMP _TX

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x17:
	RCALL SUBOPT_0x14
	ST   -Y,R31
	ST   -Y,R30
	RJMP _SnCmpr

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x18:
	RCALL SUBOPT_0x12
	ST   -Y,R31
	ST   -Y,R30
	RJMP _SnCmpr

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:14 WORDS
SUBOPT_0x19:
	LDI  R30,LOW(_RxBuf)
	LDI  R31,HIGH(_RxBuf)
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(65)
	LDI  R31,HIGH(65)
	ST   -Y,R31
	ST   -Y,R30
	RJMP _memcpy

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0x1A:
	LDI  R30,LOW(_RxBuf)
	LDI  R31,HIGH(_RxBuf)
	ST   -Y,R31
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x1B:
	LDI  R30,LOW(65)
	LDI  R31,HIGH(65)
	ST   -Y,R31
	ST   -Y,R30
	RJMP _memcpy

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:6 WORDS
SUBOPT_0x1C:
	CBI  0x12,3
	__DELAY_USW 300
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:10 WORDS
SUBOPT_0x1D:
	ST   -Y,R0
	ST   -Y,R1
	ST   -Y,R15
	ST   -Y,R22
	ST   -Y,R23
	ST   -Y,R24
	ST   -Y,R25
	ST   -Y,R26
	ST   -Y,R27
	ST   -Y,R30
	ST   -Y,R31
	IN   R30,SREG
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x1E:
	CP   R30,R6
	CPC  R31,R7
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 12 TIMES, CODE SIZE REDUCTION:9 WORDS
SUBOPT_0x1F:
	LDS  R26,_BitCount
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 10 TIMES, CODE SIZE REDUCTION:16 WORDS
SUBOPT_0x20:
	LDI  R27,0
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:10 WORDS
SUBOPT_0x21:
	LD   R30,Y+
	OUT  SREG,R30
	LD   R31,Y+
	LD   R30,Y+
	LD   R27,Y+
	LD   R26,Y+
	LD   R25,Y+
	LD   R24,Y+
	LD   R23,Y+
	LD   R22,Y+
	LD   R15,Y+
	LD   R1,Y+
	LD   R0,Y+
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x22:
	__DELAY_USW 500
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x23:
	__DELAY_USW 700
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x24:
	LD   R26,Y
	CPI  R26,LOW(0x1)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x25:
	SUBI R30,LOW(-_RxBuf)
	SBCI R31,HIGH(-_RxBuf)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0x26:
	MOVW R0,R30
	RCALL SUBOPT_0x1
	RJMP SUBOPT_0x20

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0x27:
	RCALL __EEPROMRDB
	MOVW R26,R0
	ST   X,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x28:
	RCALL SUBOPT_0x1
	RJMP SUBOPT_0x20

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x29:
	RCALL SUBOPT_0x25
	LD   R30,Z
	RCALL __EEPROMWRB
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0x2A:
	LDI  R30,LOW(100)
	LDI  R31,HIGH(100)
	RJMP SUBOPT_0xA

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x2B:
	STS  _begin,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:6 WORDS
SUBOPT_0x2C:
	LDI  R30,LOW(50)
	LDI  R31,HIGH(50)
	RJMP SUBOPT_0xA

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0x2D:
	LDI  R30,LOW(200)
	LDI  R31,HIGH(200)
	RJMP SUBOPT_0xA

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x2E:
	LDI  R30,LOW(500)
	LDI  R31,HIGH(500)
	RJMP SUBOPT_0xA

_memcpy:
	ldd  r25,y+1
	ld   r24,y
	adiw r24,0
	breq __memcpy1
	ldd  r27,y+5
	ldd  r26,y+4
	ldd  r31,y+3
	ldd  r30,y+2
__memcpy0:
	ld   r22,z+
	st   x+,r22
	sbiw r24,1
	brne __memcpy0
__memcpy1:
	ldd  r31,y+5
	ldd  r30,y+4
	adiw r28,6
	ret

_delay_ms:
	ld   r30,y+
	ld   r31,y+
	adiw r30,0
	breq __delay_ms1
__delay_ms0:
	__DELAY_USW 0x7D0
	wdr
	sbiw r30,1
	brne __delay_ms0
__delay_ms1:
	ret

__EEPROMRDB:
	SBIC EECR,EEWE
	RJMP __EEPROMRDB
	PUSH R31
	IN   R31,SREG
	CLI
	OUT  EEARL,R26
	OUT  EEARH,R27
	SBI  EECR,EERE
	IN   R30,EEDR
	OUT  SREG,R31
	POP  R31
	RET

__EEPROMWRB:
	SBIC EECR,EEWE
	RJMP __EEPROMWRB
	IN   R25,SREG
	CLI
	OUT  EEARL,R26
	OUT  EEARH,R27
	SBI  EECR,EERE
	IN   R24,EEDR
	CP   R30,R24
	BREQ __EEPROMWRB0
	OUT  EEDR,R30
	SBI  EECR,EEMWE
	SBI  EECR,EEWE
__EEPROMWRB0:
	OUT  SREG,R25
	RET

__BSTB1:
	CLT
	CLR  R0
	CPSE R30,R0
	SET
	RET

;END OF CODE MARKER
__END_OF_CODE:
