// CodeVisionAVR C Compiler
// (C) 1998-2004 Pavel Haiduc, HP InfoTech S.R.L.

// I/O registers definitions for the ATmega8


#pragma used+
sfrb TWBR=0;
sfrb TWSR=1;
sfrb TWAR=2;
sfrb TWDR=3;
sfrb ADCL=4;
sfrb ADCH=5;
sfrw ADCW=4;      // 16 bit access
sfrb ADCSRA=6;
sfrb ADMUX=7;
sfrb ACSR=8;
sfrb UBRRL=9;
sfrb UCSRB=0xa;
sfrb UCSRA=0xb;
sfrb UDR=0xc;
sfrb SPCR=0xd;
sfrb SPSR=0xe;
sfrb SPDR=0xf;
sfrb PIND=0x10;
sfrb DDRD=0x11;
sfrb PORTD=0x12;
sfrb PINC=0x13;
sfrb DDRC=0x14;
sfrb PORTC=0x15;
sfrb PINB=0x16;
sfrb DDRB=0x17;
sfrb PORTB=0x18;
sfrb EECR=0x1c;
sfrb EEDR=0x1d;
sfrb EEARL=0x1e;
sfrb EEARH=0x1f;
sfrw EEAR=0x1e;   // 16 bit access
sfrb UBRRH=0x20;
sfrb UCSRC=0X20;
sfrb WDTCR=0x21;
sfrb ASSR=0x22;
sfrb OCR2=0x23;
sfrb TCNT2=0x24;
sfrb TCCR2=0x25;
sfrb ICR1L=0x26;
sfrb ICR1H=0x27;
sfrw ICR1=0x26;   // 16 bit access
sfrb OCR1BL=0x28;
sfrb OCR1BH=0x29;
sfrw OCR1B=0x28;  // 16 bit access
sfrb OCR1AL=0x2a;
sfrb OCR1AH=0x2b;
sfrw OCR1A=0x2a;  // 16 bit access
sfrb TCNT1L=0x2c;
sfrb TCNT1H=0x2d;
sfrw TCNT1=0x2c;  // 16 bit access
sfrb TCCR1B=0x2e;
sfrb TCCR1A=0x2f;
sfrb SFIOR=0x30;
sfrb OSCCAL=0x31;
sfrb TCNT0=0x32;
sfrb TCCR0=0x33;
sfrb MCUCSR=0x34;
sfrb MCUCR=0x35;
sfrb TWCR=0x36;
sfrb SPMCR=0x37;
sfrb TIFR=0x38;
sfrb TIMSK=0x39;
sfrb GIFR=0x3a;
sfrb GICR=0x3b;
sfrb SPL=0x3d;
sfrb SPH=0x3e;
sfrb SREG=0x3f;
#pragma used-

// Interrupt vectors definitions



// CodeVisionAVR C Compiler
// (C) 1998-2006 Pavel Haiduc, HP InfoTech S.R.L.

// Prototypes for standard I/O functions


// CodeVisionAVR C Compiler
// (C) 1998-2002 Pavel Haiduc, HP InfoTech S.R.L.

// Variable length argument list macros



typedef char *va_list;





#pragma used+

char getchar(void);
void putchar(char c);
void puts(char *str);
void putsf(char flash *str);

char *gets(char *str,unsigned int len);

void printf(char flash *fmtstr,...);
void sprintf(char *str, char flash *fmtstr,...);
void vprintf (char flash * fmtstr, va_list argptr);
void vsprintf (char *str, char flash * fmtstr, va_list argptr);
signed char scanf(char flash *fmtstr,...);
signed char sscanf(char *str, char flash *fmtstr,...);




                                   

            


#pragma used-

#pragma library stdio.lib


// CodeVisionAVR C Compiler
// (C) 1998-2000 Pavel Haiduc, HP InfoTech S.R.L.


#pragma used+

void delay_us(unsigned int n);
void delay_ms(unsigned int n);

#pragma used-

// CodeVisionAVR C Compiler
// (C) 1998-2005 Pavel Haiduc, HP InfoTech S.R.L.

// Prototypes for string functions



#pragma used+

char *strcat(char *str1,char *str2);
char *strcatf(char *str1,char flash *str2);
char *strchr(char *str,char c);
signed char strcmp(char *str1,char *str2);
signed char strcmpf(char *str1,char flash *str2);
char *strcpy(char *dest,char *src);
char *strcpyf(char *dest,char flash *src);
unsigned char strcspn(char *str,char *set);
unsigned char strcspnf(char *str,char flash *set);
unsigned int strlenf(char flash *str);
char *strncat(char *str1,char *str2,unsigned char n);
char *strncatf(char *str1,char flash *str2,unsigned char n);
signed char strncmp(char *str1,char *str2,unsigned char n);
signed char strncmpf(char *str1,char flash *str2,unsigned char n);
char *strncpy(char *dest,char *src,unsigned char n);
char *strncpyf(char *dest,char flash *src,unsigned char n);
char *strpbrk(char *str,char *set);
char *strpbrkf(char *str,char flash *set);
signed char strpos(char *str,char c);
char *strrchr(char *str,char c);
char *strrpbrk(char *str,char *set);
char *strrpbrkf(char *str,char flash *set);
signed char strrpos(char *str,char c);
char *strstr(char *str1,char *str2);
char *strstrf(char *str1,char flash *str2);
unsigned char strspn(char *str,char *set);
unsigned char strspnf(char *str,char flash *set);
char *strtok(char *str1,char flash *str2);
 

unsigned int strlen(char *str);
void *memccpy(void *dest,void *src,char c,unsigned n);
void *memchr(void *buf,unsigned char c,unsigned n);
signed char memcmp(void *buf1,void *buf2,unsigned n);
signed char memcmpf(void *buf1,void flash *buf2,unsigned n);
void *memcpy(void *dest,void *src,unsigned n);
void *memcpyf(void *dest,void flash *src,unsigned n);
void *memmove(void *dest,void *src,unsigned n);
void *memset(void *buf,unsigned char c,unsigned n);

#pragma used-
#pragma library string.lib



//#define TRFreset    0   //  - ,    ,  

//#define BGRX_NoiseH 3
//#define BGRX_NoiseL 4







//#################################################                      
//#define TETest 	  PORTC.1	//
//#define Switch	  PORTD.0       //PIN                           

//#define BtnT 	  PINB.7	// 
//#define BtnM 	  PINC.5	// 


//#define LedB 	  PORTD.3	//

//#define LedM1 	  PORTC.3	//
//#define LedM2 	  PORTC.2	//
//#define LedM3 	  PORTC.1	//

//#define Vibro 	  PORTD.1	//
//#################################################

typedef unsigned char byte; // unsigned char  "byte"
//typedef unsigned int byte;      // one byte unsigned
typedef signed   int  sbyte;     // one byte signed
typedef signed   long word;      // one word signed

#pragma warn- //    
eeprom byte EprBuf0 [65];	// 0   
eeprom byte EprBuf1 [65];	// 1   
eeprom byte EprBuf2 [65];	//  2  - 

eeprom byte eep_ring;
#pragma warn+ //   

//int   TE_Test_CNT;

int   RFcount;           //  TE
int   BGRXcnt;                        
int   LastRxCnt;   
int   LedPulse;

int  NError;                             
//byte  ErrLength;

//byte  ErrLevel;

byte  BGRX;
byte  RFstate;   //  - 
byte  BitCount;          //   
//byte  L3FErCNT;

bit   ActiveBuf;         //   (         )
bit   RFFull;           //               
bit   TXFlag;           //         

//byte  ring;                                
byte  CellNo;      
byte  Grab; //  0,1     2 -   
byte  begin;

//bit   RFBitM;            //     
//bit   RFBitS;            //     

byte i;                 //  i     for

byte	    RxBuf   [65];   // /
byte	    RxBufLox[65];	//     

byte	    RxBuf1  [65];	//   1
byte	    RxBuf2  [65];	//   2

//   
void Beep2(void);
void Beep2(void);
void Beep(void);
void SetActive (void);

//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
byte SnCmpr(byte *TestBuf)
{//    
byte HOPcmp;    
//RFFull=1;

for (i = 32; i != 60; i ++)
    {
    if (RxBuf[i] != TestBuf[i])
       {		     
  //     RFFull=0;  //   ,   
       return 0;  //   0
       }		                 
    }   

//***	

for (i = 0; i != 32; i ++) //  
    {
    if (RxBuf[i] != TestBuf[i])
       {		     
       HOPcmp=1;      
       }		                 
    }      
    
if (!HOPcmp)      	
    return 0;

//***   	
		         
for (i = 60; i != 63; i ++) // 
    {
    if (RxBuf[i] != TestBuf[i])
       {		     
       return 2;      
       }		                 
    }   
       	 
    	         		         
return 1;		         
} 
//-------------------------------------------------------------------------------------------------------------------------
//#########################################################################################################################

void TX (byte* TxBuf)
{           

BGRX    = 0;
RFstate = 2   ;                 

//#asm("cli") 
PORTC.0	=1;
//Vibro=0; 
//Switch=1; // 
//========================================================================_Prambule	
//    24 :  =0  a=23,    1 
	for(i = 0; i != 31; i++)
       	{
       		PORTD.2	 = 0;
       		delay_us(400        );

       		PORTD.2	 = 1;       		
       		delay_us(400        ); 
       	}
//========================================================================_HeaderTX
PORTD.2	 = 0;
delay_ms (4);
//========================================================================_BuffTX
//--------------------------------//1- 
//    
   
   for(i = 0; i != 66; i++) //
   {
    PORTD.2	 = 1;      
        
//    if (ring!=1)
        PORTD.3	= 1;
        
    delay_us(400        );    
      
    PORTD.2	=TxBuf[i];       
    delay_us(400        );

    PORTD.2	 = 0;    
    PORTD.3	= 0;
    delay_us(400        );
   }  
    /*
    RFOut = 1;      
    delay_us(TE);    
      
    RFOut=0;       
    delay_us(TE);

    RFOut = 0;    
    delay_us(TE);
*/                  
    
//========================================================================_GuardTime                                                  
//Switch = 0;      //   =)
//Vibro=1; 
PORTC.0	=0;    
RFFull=0;
//#asm("sei") 
delay_ms (10);	//  15ms,       	 

RFstate = 0   ;
}      


//#########################################################################################################################
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
void BTNcomp(void) //   
{
if ((Grab>1 && SnCmpr(RxBufLox)==2) && Grab<4) //   - Grab = 1  //    
   {                                                                                                           
   Grab++;   
   if (ActiveBuf==0)//   Buf0(    )
      {
      ActiveBuf = 1;
      TX(RxBuf2); 
      Beep();
      TX(RxBuf2);
      }
  else//   Buf1(    ),   Buf0
      {            
      ActiveBuf = 0;
      TX(RxBuf1); 
      Beep();   
      TX(RxBuf1);
      }            
   }                           
   
//-----------------------------------------------------------------------------------------------------------------

if (Grab==1  && RFFull) //     ,    
   {                                                                     
   TX(RxBuf);    
   Beep();
   TX(RxBuf);       
   }
                                         
}  

//#########################################################################################################################


void SetActive (void)
{                                                       
if ( (SnCmpr(RxBuf1)==2 || SnCmpr(RxBuf2)==2) && begin >= 2 && Grab==0) 
// if ( (((SnCmpr(RxBuf1)==2) || (SnCmpr(RxBuf2)==2)) && (Grab!=2)) && (begin >= 2) && (Grab!=1)) 
    {          
    memcpy(RxBufLox,RxBuf, 65); //   LOX                 //         
    RFFull=1;
    PORTC.1	=1;         
    Grab=2;      
    Beep2();
    }                       
    
//--------------------------------------------------------------------------------------------------------

if (Grab<2 && ( SnCmpr(RxBuf1) || SnCmpr(RxBuf2) || begin<2 ) )                                                 //      
   {                                                    
   if (ActiveBuf==0)//   Buf0(    )
      {                                              
         ActiveBuf = 1;		//  Buf1                       
         memcpy(RxBuf2,RxBuf, 65); //   RxBuf2                          
         memcpy(RxBuf, RxBuf1,65); //  RxBuf1   
         RFFull=1;
      }
   else//   Buf1(    ),   Buf0
       {   
  	      ActiveBuf = 0;		//  Buf0      
	      memcpy(RxBuf1, RxBuf,65); //   RxBuf1     
	      memcpy(RxBuf, RxBuf2,65);//  RxBuf2         
	      RFFull=1;
       }        
   }    

}


//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//interrupt [TIM0_OVF] void MainRecive(void) // ,   
interrupt [10] void timer0_ovf_isr(void)
interrupt [10] void timer0_ovf_isr(void)
{
//#############  +
TCNT0=135;
// - ,  - 
        
//LedG=0;
//LedR=0;
 
NError++;
/*      if (NError >= 50)
	 {          	           		   
	 NError = 0; 
	 if (RFstate == TRFSYNC)
            {
            Switch = 1;            
	    RFstate = TRFError;
//	    LedR   = 1;
	    RFOut  = 1;
	    
            BGRXcnt = 0;     
//          RFcount = 0;    
            }	 
	 } */

switch(RFstate)  //           
{
//************************************************

//************************************************
 case 3 : //   ,  HEADER


// RFcount+10;      

/* delay_us(400);
 RFOut = 0;
 delay_us(50); 
 RFOut = 1;    
 delay_us(200);   */
        
// delay_us(150);   
 
 //RFcount=20;         
// LedR=0;
// LedG=0;        
 PORTD.2	 = 0;  
 RFstate = 4   ; 
 
 break;

//************************************************

 case 4   : //   ,  HEADER     
                   
      PORTD.2	 = 1;
      RFstate = 5   ;
 
 break;
//************************************************ 

 case 5   : //   ,  HEADER     
                   
      PORTD.2	 = 0;         
      //delay_us(100);
      RFstate = 6            ; 
 
 break;                                             
 
 //************************************************ 

 case 6            : //   ,  HEADER     
                             
//      Switch = 0;        
      RFstate = 0   ; 
 
 break;
//************************************************************************************************************************************

 case 2   ://   
                                        
 //LedR=1;
 RFcount = 0; //          

 break;

//*************************************************
 case 0   : //                       
                             
 default:                                      
              
/*      if (NError >= 50)
	 {          	           		   
	 NError = 0;
         Switch = 1;   
         RFOut  = 1;            
	 RFstate = TRFError;  
	 }    */   
                      
 if (PINC.5	 == 1)
    {            
    //LedG=1;
    
    
//     TETest=1; //               !!!        
     // rising edge detected  +---+                +---..
     //                       |   |  <-Theader->   |   
     //                           +----------------+                                                                
     BGRXcnt = 0;
     RFcount = 0;      	                                    
     BitCount= 0; 
     //L3FErCNT= 0;                                                             
     RFstate = 2   ;                 
     BGRX = 1;      
     //RFcount = 0; // HEADER-a  0
     //NError = 0;  //   0                     
    }
    
 else
     {      
     //LedR=1;
     
//     TETest=0; //               !!!         
     RFcount++; //  HEADER	          
     if (RFcount == 10)// && NError > 50 )
        {            
         NError = 0;
        // RFcount= 0;                                                        
         RFstate = 3 ; 	      
//         Switch= 1;	 
	 PORTD.2	 = 1; 
        }      
     }                

break;

//*************************************************************************************************************************************
       
    } // switch    */     
 
}
void RFError(void) //   
void RFError(void) {
//Switch = 1; 
PORTD.2	=1;

//if (ring!=1)
	for(i = 0; i != 10; i++)
	   {
	   PORTD.3	=1;
	   delay_us(300);
	   PORTD.3	=0; 
	   delay_us(150);	   
	   }    
 
PORTD.2	=0; 
RFstate = 0   ;
//Switch = 0; 
}


//***************************************************************

//BackGroundRecive
//interrupt [TIM0_OVF] void timer0_ovf_isr(void)
interrupt [9] void timer1_ovf_isr(void)
{          
BGRXcnt++;


switch(BGRX)
      {
//#######################################################################################################################
//##############################################     ##################################################
//#######################################################################################################################

      case 1:

	   if ( BGRXcnt == 8) // Optimal read-point for MASTER reciver  7,  10
	      {
//	      TETest=0; //              !!!
	      
	      if (RFFull == 0)
                 RxBuf[BitCount]=PINC.5	;     //   1/3 ,        

                 if (BitCount == 5 || BitCount == 10 || BitCount == 15 || BitCount == 20 || BitCount == 25 || BitCount == 30 || BitCount == 35 || BitCount == 40 || BitCount == 45)
                 //if (L3FErCNT >= 5 && BitCount > 5)
                    { 
                    //L3FErCNT=0;
                    //Switch = 1;
                    PORTD.2	=1;
                    }

	      ++BitCount;
	      //++L3FErCNT;

              if (BitCount == 63) //   -
         	 {
         	 //Switch = 1;
//       	 Vibro=0;
         	 RxBuf[63]=1;
                 LastRxCnt=0;	      //    
                 TXFlag  = 1;

  		 if (RFFull == 0)   //     
 	            SetActive();      //  

         	 PORTC.0	=1;
                 BGRX    = 0; //   
   		 RFstate = 0   ;
        	 RFError();
//   		 Vibro=1;

		 break;
    	         }
	      }

if ( BGRXcnt == 13)
   {
   PORTD.2	=0;
   //Switch = 0;
   }


	   if (BGRXcnt == 15) // 13      16 //     
	      {              
	      if (PINC.5	 == 1 && BitCount < 5)
	         {
	         //RFstate = TRFSYNC;
	         BGRX    = 0;
	         RFstate = 3 ;
	         }
	      
  	      //RFcount = 0;
	      BGRX    = 2; //
	      }

//          }      

      break;
     
     
//********************************************************************

      case 0:
      
      
      break;
           
//********************************************************************

      case 2:  
      default:
 
 if (PINC.5	 == 1) //   
    {
//    TETest=1;                  //           !!!
    
     // rising edge detected     +----
     //                          |
     //                      ----+     
     BGRXcnt = 0;     
     //RFcount = 0;                // reset length count                  
     BGRX    = 1; 
     break;        	             	         
     } 
  
    if (BGRXcnt > 35) //     10
       {       
       //RFcount=0;                          
       BGRX   = 0; 
       //RFstate = TRFSYNC;      
       RFstate = 3 ; // 
       }     
  
      break;

      }                                                      
}                     


//------------------- 
void Beep2(void)
void Beep2(void)
{        
//Switch = 1; 
PORTC.0	=1;    
//Vibro=0;
PORTD.2	=1;

for(i = 0; i != 250; i++)
   {
   PORTD.3	=1;
   delay_us(150);
   PORTD.3	=0;
   delay_us(150);
   }  
PORTC.0	=0;   
for(i = 0; i != 200; i++)
   {
   PORTD.3	=1;
   delay_us(250);
   PORTD.3	=0;
   delay_us(250);
   }   
PORTC.0	=1;   
for(i = 0; i != 150; i++)
   {
   PORTD.3	=1;
   delay_us(350);
   PORTD.3	=0;
   delay_us(350);
   }   

PORTD.2	=0;      
//Vibro=1;   
PORTC.0	=0;
//Switch = 0; 
}

//************************************************************************************************

void RWCell(byte M)
{
switch (CellNo)
       {       
//-------------------------------------       
	    case 0:
		     for (i = 0; i != 66; i ++)
		         {
		         if (M==1)
  		            RxBuf[i]   = EprBuf0[i];				                  		        
		        else   
		            EprBuf0[i] = RxBuf[i];
		         }
        break;
//------------------------------------- 
	    case 1:
		     for (i = 0; i != 66; i ++)
		         {
		         if (M==1)
  		            RxBuf[i]   = EprBuf1[i];				                  		        
		        else   
		            EprBuf1[i] = RxBuf[i];
		         }
		break;
//------------------------------------- 
		case 2:
		     for (i = 0; i != 66; i ++)
		         {
		         if (M==1)
  		            RxBuf[i]   = EprBuf2[i];				                  		        
		        else   
		            EprBuf2[i] = RxBuf[i];
		         } 
		break;
//-------------------------------------		
	   }  
	   	   
if (M==1) //     > RAM
   {
   TX(RxBuf);
   delay_ms(100);
   TX(RxBuf);
   }
else         
   {
   *RxBuf=0;
   *RxBuf1=0;
   *RxBuf2=0;
   }
    
Beep2();   
}

//************************************************************************************************

void Cell_Select(void)
{         
Beep();

if (CellNo == 0)
   {
   CellNo   = 1;
   delay_ms(100);
   Beep();   
   return;
   }

if (CellNo == 1)
   {
   CellNo   = 2;
   delay_ms(100);
   Beep();           
   delay_ms(100);
   Beep();
   return;
   }

if (CellNo == 2)
   {
   CellNo   = 0;
   return;
   }
      
}


//************************************************************************************************
//--------------------  ,      =)         
void Beep(void)
{          
//Switch = 1; 
PORTD.2	=1;

//if (ring!=1)
	for(i = 0; i != 100; i++)
	   {
	   PORTD.3	=1;
	   delay_us(200);
	   PORTD.3	=0; 
	   delay_us(150);	   
	   }    
/*else
   {	   
   Vibro=0;   
   delay_ms(100);
   Vibro=1;   
   }*/
 
PORTD.2	=0; 
//Switch = 0; 
}                                                                                                 

interrupt [5] void timer2_ovf_isr(void)
{            
LastRxCnt++; 
LedPulse++;          

if (LastRxCnt > 6000) //     50ms
   {
   LastRxCnt=0;  
   if (TXFlag)
      { 
      begin++;     
      BTNcomp(); //            	 
//      Vibro=1;    
      PORTC.0	=0;   
      RFFull=0;
      TXFlag=0;
      Beep();
      }                    
   }                 
   
       

//****   

if ( LedPulse>3000)
   {    
   if (Grab != 1)   
       PORTC.1	  = 1;
      
 /*  LedM1 = 1;
   LedM2 = 1;
   LedM3 = 1;  */
   }        
   
if ( LedPulse>4000)
   {   
	if (Grab < 2)   
	    PORTC.1	  = 0;    
	          
       /*	if (CellNo != Cell_0)   
	    LedM1 = 0;   
	if (CellNo != Cell_1)   
	    LedM2 = 0;   
	if (CellNo != Cell_2)   
	    LedM3 = 0;     */
   
	   LedPulse=0;
   } 
                             
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//byte GrabTMP;
//int BtnTime;             
//************************************************************************************************
//---------------------------------------------------------------- 
if (PINC.3	==0) 
    delay_ms(50);

 if (PINC.3	==0) 
    {             
    delay_ms(200);
    PORTC.0	=1;
    if (PINC.3	==1)//  50ms 
       {                
       begin=0;    
       if (Grab==1)
          {
          RFFull=1;   
          begin=0;
          SetActive();  //  
          BTNcomp();    //  RAM         
          }           
      else             
          {
          Grab=0;                                    
          TX(RxBufLox); //  RAM                           
          delay_ms(200);          
          TX(RxBufLox);                          
//          LedG=0;                  
          }
       }   
   else
       {
       delay_ms(500);
       if (PINC.3	==0)//  300ms  
          {
          RWCell(1);  //    EEPROM
          Cell_Select();
          }
       }
    PORTC.0	=0;        
    
    while (PINC.3	==0) //   
          {
          delay_ms(10);                               
          }    
    }
        
//----------------------------------------------------------------                   

if (PINC.4	==0) 
    delay_ms(50);

 if (PINC.4	==0)  //   ""
    {           
//    BtnTime++;    
    delay_ms(200);
    if (PINC.4	==1)//  50ms 
       {
       Cell_Select();            // 
       }
    else
        {
        delay_ms(500);
        if (PINC.4	==0)//  300ms   
           {                                                                
           begin=0; 
                                                
           if (Grab>1)
              {       
              memcpy(RxBuf,RxBufLox, 65); //   LOX-                                          
              Grab=0;
              PORTC.1	=0;
              }
          else 
              {            
              SetActive();
              RFFull = 0;                             
              }
                                                                                                                      
           RWCell(0);             //   RxBuf-                                 
           Cell_Select();
           
  	       for (i = 0; i != 66; i ++)
		         {		         
  		         RxBuf [i] = 0;
  		         RxBuf1[i] = 0;
  		         RxBuf2[i] = 0;
		         }
                                 
           }  
           
    while (PINC.4	==0) //   
          {
          delay_ms(10);
          }           
        }
   }    
  
//----------------------------------------------------------------  /             

if (PINC.2	==0) 
    delay_ms(50);

 if (PINC.2	==0)  //   ""
    {           
//    BtnTime++;    
    delay_ms(200);    
    PORTC.0	=1;                
    if (PINC.2	==1)//  50ms 
       {       
       if (Grab != 1)//    
           Grab=1;
       else       
           Grab=0;
           
       Beep();    
       }
   else 
       {          
       PORTC.0	=1;
       delay_ms(500);
       if (PINC.2	==0)//  300ms   
          {                                         
/*          ring=eep_ring;
          
          if (ring)    
             ring=0;                   
          else
             ring=1;
             
          eep_ring=ring;   */
                    
           Beep();
           Beep();
          }                 
       }           
    
    PORTC.0	=0;                        
    while (PINC.2	==0) //   
          {
          delay_ms(10);
          }           

   }                   
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

}




// Declare your global variables here


// Declare your global variables here

void main(void)
{
// Declare your local variables here

// Input/Output Ports initialization
// Port B initialization
// Func0=In Func1=In Func2=In Func3=Out Func4=In Func5=Out Func6=In Func7=In
// State0=P State1=P State2=P State3=0 State4=T State5=0 State6=T State7=T
PORTB=0x07;
DDRB=0x28;

// Port C initialization
// Func0=Out Func1=Out Func2=In Func3=In Func4=In Func5=In Func6=In
// State0=0 State1=0 State2=P State3=P State4=P State5=T State6=T
PORTC=0x1C;
DDRC=0x03;

// Port D initialization
// Func0=Out Func1=Out Func2=Out Func3=Out Func4=In Func5=In Func6=In Func7=In
// State0=0 State1=0 State2=0 State3=0 State4=T State5=T State6=T State7=T
PORTD=0x00;
DDRD=0x0F;

// Timer/Counter 0 initialization
// Clock source: System Clock
// Clock value: 1000,000 kHz
TCCR0=0x02;
TCNT0=0x00;

// Timer/Counter 1 initialization
// Clock source: System Clock
// Clock value: 8000,000 kHz
// Mode: Ph. correct PWM top=00FFh
// OC1A output: Discon.
// OC1B output: Discon.
// Noise Canceler: Off
// Input Capture on Falling Edge
TCCR1A=0x01;
TCCR1B=0x01;
TCNT1H=0x00;
TCNT1L=0x00;
OCR1AH=0x00;
OCR1AL=0x00;
OCR1BH=0x00;
OCR1BL=0x00;

// Timer/Counter 2 initialization
// Clock source: System Clock
// Clock value: 8000,000 kHz
// Mode: Normal top=FFh
// OC2 output: Disconnected
ASSR=0x00;
TCCR2=0x01;
TCNT2=0x00;
OCR2=0x00;

// External Interrupt(s) initialization
// INT0: Off
// INT1: Off
GICR|=0x00;
MCUCR=0x00;

// Timer(s)/Counter(s) Interrupt(s) initialization
TIMSK=0x45;

// Analog Comparator initialization
// Analog Comparator: Off
// Analog Comparator Input Capture by Timer/Counter 1: Off
// Analog Comparator Output: Off
ACSR=0x80;
SFIOR=0x00;

		      PORTC.0	 = 1;        //  
		      PORTC.1	 = 1;
//****
/* if (BtnMode==0)  //   ""
    {             
    delay_ms(500);
    if (BtnMode==0)//  300ms   
       {                                         */
      
		for(i = 0; i != 10; i++)
		      {      
		      PORTC.0	 = 1;        //  
		      PORTC.1	 = 0;
		      delay_ms(50);    //  50ms
			  PORTC.0	 = 0;        //s        
			  PORTC.1	 = 1;
		      delay_ms(50);    //  50ms      
		      }                                       
		      PORTC.1	 = 0;
		      Beep2();            
		
		Grab=1;//          
//		ring=eep_ring;

/*                 
Switch= 1;                              
 while (1)       //     
       {                
       RFOut=1;
       delay_ms(1);
       RFOut=0;
       delay_ms(1);
       }		
*/		
		// Global enable interrupts
		#asm("sei")  
  //     }               
   // }  

//***          




}
